	Subroutine Contwf(Nstate,Nstate3,iop,nop1,nop,EEE,Srmat,Simat,
     X                   f,fp,f2,fp2,SS,VAL,VEC,phi,fuh,trbas,trchan,
     X		     	 callxlr,STIL)
	use globals
	use gs, only: nstgs
	use scattering
	implicit real*8 (a-h,o-z)
	parameter (PI=3.1415926536d0)
	real*8 f(Nstate3,Nstate3,2),fp(Nstate3,Nstate3,2),Fnorm(MCHAN3)
	real*8 f2(Nstate3,Nstate3,2),fp2(Nstate3,Nstate3,2)
	real*8 SS(nchmax,numrmax),VAL(nchmax),VEC(nchmax,nchmax)
	real*8 phi(MCHAN,nchmax),Srmat(nop1,nop),Simat(nop1,nop)
 	complex*16 fuh(MNOP,MCHAN3,NMAXF),Ac,CWF(MCHAN3),CWFP(MCHAN3),
     X             Bc(nmax,MCHAN3),trchan(MNOP,MCHAN3,nstgs),
     X		   STIL(nop1,nop),CWFB(MCHAN3)
	real*8 trbas(nstgs,nchmax)
	logical callxlr
	integer iop(nop1)

	nopp=0
	do iom=1,nop
         m = iop(iom)
	 if(KFAD(m).eq.1.and.lchl(m).le.mlpr) nopp=nopp+1
	 enddo

	do 100 iom=1,nop
         m = iop(iom)
C                             m = incoming channel, i = outgoing channel
  	  do i=1,Nstate3
	  if(e1only.and.GO) then
	    do in=1,nstgs
            trchan(iom,i,in)=0d0
	    enddo
	  endif
	  enddo
	   do i=1,Nstate3
	    if(.not.callxlr) then
		CWFP(i) = cmplx(fp(i,m,2),-fp(i,m,1))
		CWF(i)  = cmplx(f(i,m,2), -f(i,m,1))
	    do ioj=1,nop1
		j = iop(ioj)
		CWFP(i) = CWFP(i) -
     X			   cmplx(fp(i,j,2),fp(i,j,1))
     X		 	 * cmplx(Srmat(ioj,iom),Simat(ioj,iom))
		CWF(i) = CWF(i) -
     X			   cmplx(f(i,j,2),f(i,j,1))
     X		 	 * cmplx(Srmat(ioj,iom),Simat(ioj,iom))
	    enddo
	    else
		CWF(i)  = fuh(iom,i,numrs1)
		CWFP(i) = fuh(iom,i,numrs1-1)
	    endif
	    CWFB(i) = CWFP(i) - beta * CWF(i)
	   enddo
	if(fadex.gt.1) then
c			    Now CWFB = N * (CWFP-beta.CWF)
	    do 10 i=1,Nstate
	    CWFB(i) = 0d0
	    do 10 j=1,Nstate
10	    CWFB(i) = CWFB(i) + WN1(i,j) * (CWFP(j) - beta * CWF(j))
	endif

	do 30 i=1,Nstate
	do 30 n1=1,nsturm
30	  Bc(n1,i) = (0d0,0d0)
	do k=1,neigs	
	  Ac = (0d0,0d0)	
	  do i=1,Nstate3
	    Ac = Ac + CWFB(i) * phi(i,k) / (VAL(k)-EE) 
	  enddo
	  Ac = Ac * ryev
         do i=1,Nstate
             do n1=1,nsturm 
                nn1=n1+(i-1)*nsturm
		Bc(n1,i) = Bc(n1,i) + VEC(nn1,k) * Ac
             enddo
         enddo
       enddo 
	if(e1only.and.GO) then

	  do 71 i=1,Nstate3
	  do 71 j=1,Nstate
             if(fadex.le.1) then
               T = WN1(i,j)
               if(KFAD(i).gt.1) T = T*0.5
             else
c       if fadex=2 or 3, no reduction
               T = 0.0
               if(i.eq.j) T = 1.0
             endif
            if(abs(T).gt.1e-8) then
	     do 70 n1=1,nmax
                nn1=n1+(j-1)*nsturm
	     do 70 in=1,nstgs
70           trchan(iom,i,in)=trchan(iom,i,in)+Bc(n1,j)*trbas(in,nn1)*T
	    endif
71	  continue

	else if(wfs) then
C				Interior wave function
	do 85 i=1,Nstate
	  do irs=1,numrs1-1
      	    fuh(iom,i,irs)=0d0
	  enddo
        do 80 n1=1,nsturm 
           nn1=n1+(i-1)*nsturm
	do 80 ir=1,numrs1-1
	  irs = ir*iwfskp
80        fuh(iom,i,ir)=fuh(iom,i,ir)+Bc(n1,i)*SS(nn1,irs)
85	continue
C				Exterior wave function
	if(.not.callxlr) then
	do 90 irs=numrs1,numrs
	   r = irs*steps
	      call Asyuwfn(r,Nstate3,EE,f2,fp2)
	    do i=1,Nstate3
		CWF(i) = cmplx(f2(i,m,2),-f2(i,m,1))
	     do ioj=1,nop1
		j = iop(ioj)
		CWF(i) = CWF(i) - cmplx(f2(i,j,2),f2(i,j,1))
     X			* cmplx(Srmat(ioj,iom),Simat(ioj,iom))
	     enddo
	   fuh(iom,i,irs) = CWF(i)
	   enddo
90	continue
	endif

	if(FAD) then
c				Choose to give wfn PROJECTED onto each channel!
c				and to multiply the Y-channel wfs by 1/2      !
	 do 95 irs=1,numrs
	   r = irs*steps
	   do 92 i=1,Nstate
92	    CWF(i) = fuh(iom,i,irs) 
	   do i=1,Nstate3
	    fuh(iom,i,irs) = 0d0
	       do j=1,Nstate
                 T = WN1(i,j)
                 if(KFAD(i).gt.1) T = T*0.5
	         fuh(iom,i,irs) = fuh(iom,i,irs)  + T * CWF(j)
	       enddo
	   enddo
95	continue
	endif

C
C *********************************************************
C
	if(.not.e1only) then
C   ***  INNER NORM OF DIAGONAL COMPONENTS  ****
C
	   Fnorm(iom) = 0.0
      	   do 2100 irs=1,numrs1
	   r = irs*steps
	   if(glag) r = rrad(irs)
	   h = wrad(irs) * iwfskp
	  if(r.gt.rinte) go to 2101
2100  	   Fnorm(iom) = Fnorm(iom) + abs(FUH(iom,iop(iom),irs))**2 * h
2101  	   continue
	endif

	if(lprwf.ge.3.and.KFAD(m).eq.1.and.lchl(m).le.mlpr) then
      	   write(8,4001) m,ee,STIL(iom,iom),Srmat(iom,iom),Simat(iom,iom)
4001  	   format('# Continuum WF*i/2 from ch',I3,' at',f8.4,', Sel=',
     x             2f12.6,:,' from',2f12.6)
4002  	   format('# Continuum WF*i/2 in ch ',i3,' from',I3,' at',f8.4,
     x             ', Sel=',2f12.6)
	   do i=1,min(Nstate3,4)
	    ii=(i-1)*nopp+iom
      	    write(700+ii,4002) i,m,ee,STIL(iom,iom)
	    enddo
      	   do 4120 irs=2,numrs,2
	   r = irs*steps
	   if(glag) r = rrad(irs)
  	   write(8,4121) r,(fuh(iom,i,irs)*(0.,.5),i=1,min(Nstate3,5))
	   do i=1,min(Nstate3,5)
	    ii=(i-1)*nopp+iom
	    write(700+ii,4121) r,fuh(iom,i,irs)*(0.,.5)
	   enddo
4120  	   continue
      	   write(8,*) '&'
	   do i=1,min(Nstate3,5)
	    ii=(i-1)*nopp+iom
	    write(700+ii,*) '&'
	   enddo
c4121  	   format(1x,f8.3,10g12.3)
4121  	   format(1x,f8.3,10f9.5)
        endif
!	if(lprwf.ge.2.and.KFAD(m).eq.1.and.lchl(m).le.mlpr) then
	if(lprwf.ge.2.and.m.eq.1.and.lchl(m).le.mlpr) then
      	   write(9,4001) m,ee,STIL(iom,iom),Srmat(iom,iom),Simat(iom,iom)
      	   do 4124 irs=1,numrs,1
	   r = irs*steps
	   if(glag) r = rrad(irs)
4124  	   write(9,4121) r,fuh(iom,iom,irs)*(0.,0.5)
      	   write(9,*)  '&'
        endif
	endif

100	continue
	if(.not.e1only) then
	XX =  (2*JTOT+1) / (0.5D0*DSQRT(2.D0/PI))
      SUM   = 0.0D0
      DO 2115 I = 1  ,nop
        Fnorm(I)     = Fnorm(I)*XX
 2115 SUM      = SUM     +Fnorm(I)
c     DO 4115 I = 1  ,nop
c4115 Fnorm(I)     = Fnorm(I)/SUM
      WRITE(30,9339)EE,SUM,(Fnorm(I),I=1,min(10,nop))
c9339  FORMAT(1X,F7.3,G11.3,10f8.4)
 9339  FORMAT(1X,F8.4,11G11.3)
c	write(30,9339) EE,XX,PI,h,rinte,real(numrs1)
	endif
	return
	end
