*==> denanr.f <==   
      SUBROUTINE DENANR (FUN,H,NMAR,RRDD,WRDD,
     X			KSTQ,NSTATE,KFD,ENGY)
C *** DENSITY OF N+N AS A FUNCTION OF   CORE-P+P DISTANCE
C
	use globals
c	use gs
      IMPLICIT DOUBLEPRECISION (A-H,O-Z)
      DIMENSION KSTQ(MCHAN,7),KFD(MCHAN)
      DIMENSION FUN(NSTATE,NMAR),RRDD(NMAR),WRDD(NMAR)
      DIMENSION DNN(mchan**2),WNN(mchan**2),WEI(NSTATE)
       prtran = .false. 

	if(prtran) write(4,*) 'DENANR:'
      PI = 4d0*ATAN(1d0)
C   STURMX:
	RM = H*NMAR
	WVK =SQRT(MAX(-ENGY,0d0)/ryev)
	if(prtran) write(4,*) 'RM,H,ENGY,WVK,NSTATE =',
     x			       RM,H,ENGY,WVK,NSTATE
	if(prtran) write(4,*) 'mchan =',mchan
	if(prtran) call flush(4)
!				Get information from globals for local use:
!				DENANR assumes 1,2 are nucleons, 3 is core!
	A1 = mass(1)
	A2 = mass(2)
	A3 = mass(3)
	RCORE = radius(3)
	Z3 = charge(3)
C
      S2    = DSQRT(0.5D0)
      S3   =  DSQRT(1.D0/3.D0)
      S23   =  S3*2.D0
      SPI   =  DSQRT(2.D0/PI)
      DO 977 I = 1,NSTATE**2

      WNN(I) = 0.D0
 977  DNN(I) = 0.D0
          WEI(:) = 0.D0
      T1 = 0.D0
      T2= 0.D0
      T4= 0.D0
      T5= 0.D0
      T6= 0.D0
      T7= 0.D0
      T8= 0.D0
      T9= 0.D0
      T10=0.D0
C
      DO 51 J = 1,NMAR
      RO2=RRDD(J)**2
      T = 0.D0
C
      DO 52 I = 1,NSTATE
      if(KFD(I).ne.1) go to 52
        DNN(I) = DNN(I) + FUN(  I,J)**2*RO2 * WRDD(J)
        T = T + FUN(I,J)**2 * WRDD(J)
        WNN(I) = WNN(I) + FUN(I,J)**2 * WRDD(J)
         WEI(I) = WNN(I)

  52  continue
      T2 =T2+ T
  51  T1 =T1+ T*RO2

	if(prtran) then
       DO 993 I = 1,NSTATE
 	  WRITE(4,997) (KSTQ(I,J),J=1,5),DNN(I),WNN(I)
	  if(prtran) call flush(4)
 993  continue
	endif
      DO 994 I = 1,NSTATE**2
 994  WNN(I) = 0.D0
C 993  CONTINUE
	if(ENGY.lt.0.0) then
      DO752 I = 1,NSTATE
      if(KFD(I).ne.1) go to 752
      asa=FUN(  I,NMAR)**2*(RM**2+RM/WVK+0.5D0
     *  /WVK**2)/(2.D0*WVK)
       if(prtran) WRITE(4,9197) wvk,asa,fun(i,nmar),rm
	if(prtran) call flush(4)
 9197  format(1x,4g14.4)
      DNN(I) = DNN(I)    +asa
 752  CONTINUE
	endif
C
C
      DO 7788 I = 1,NSTATE
      if(KFD(I).ne.1) go to 7788
      T7 = T7 + DNN(I)
	if(ENGY.lt.0.0) T2 = T2 + FUN(  I,NMAR)**2/(2.D0*WVK)
 7788 continue
      RO2 = T7   /T2
       RSUM = 0.D0
       DO 988 I = 1,NSTATE
       if(KFD(I).ne.1) go to 988
       DNN(I) = DNN(I)   /T2
       if(prtran) WRITE(4,997) (KSTQ(I,J),J=1,5),DNN(I)
	if(prtran) call flush(4)
 988    CONTINUE
C ***  CALC OF <K L1 L2/RO**2*COS(TETA)**2/K1 L1 L2>    ****
       IJ = 1
       cs2 = 0.d0

      DO 8765 I = 1,NSTATE
      K  = KSTQ(I,1)
      LL1= KSTQ(I,2)
      JS1= KSTQ(I,3)
      L1 = KSTQ(I,4)
      L2 = KSTQ(I,5)
       JBEG  = I
      DO 8765 J = JBEG,NSTATE
       if(KFD(J).ne.1.or.KFD(I).ne.1) go to 8765
      K1 = KSTQ(J,1)
      LL2= KSTQ(J,2)
      JS2= KSTQ(J,3)
      L12= KSTQ(J,4)
      L22= KSTQ(J,5)
       WNN(IJ) = 0.d0

      IF(LL1 .NE. LL2) GO TO 8765
      IF(JS1 .NE. JS2) GO TO 8765
      IF( L1 .NE. L12) GO TO 8765
      IF( L2 .NE. L22) GO TO 8765
       IF(I .NE. J) GO TO 8767
      IF( L1 .EQ.  L2) GO TO 8766
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+1.5D0)*(AN+L1+L2+2.D0)/(K+3)
      C2 =  AN*(AN+L1+.5D0)/(K+1)
      C1 =  (C1+C2)/(K + 2)
       WNN(IJ) = DNN(I)*C1
       if(prtran) WRITE(4,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
	if(prtran) call flush(4)
       IJ = IJ + 1
       cs2 = cs2 + C1*WEI(I)

         GO TO 8765
C
 8766  C1 = 0.5D0
       WNN(IJ) = DNN(I)*C1
       if(prtran) WRITE(4,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
	if(prtran) call flush(4)
       IJ = IJ + 1
       cs2 = cs2 + C1*WEI(I)

         GO TO 8765
C
 8767  CONTINUE
       IF((K+2) .NE.K1) GO TO 8765
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K1+2)
      C1 =  AN*(AN+L1+.5D0)/ K1   * C1
      C1 =  DSQRT(C1)/(K1+1)
       weind = 0.d0

      DO 9651 M = 1,NMAR
      R2=RRDD(M)**2
      weind=weind+ FUN(I,M) * FUN(J,M) * WRDD(M)

      IF(WNN(IJ).gt. 1.d10)write(4,*)'IJ,I,J,WNN(IJ)',IJ,I,J,WNN(IJ)

      WNN(IJ)=WNN(IJ)+ FUN(I,M) * FUN(J,M)* R2 * WRDD(M)

c      IF(WNN(IJ).gt. 1.d10)write(4,*)'FUN(I,M) * FUN(J,M)* R2 * WRDD(M)'

c     * ,FUN(I,M), FUN(J,M), R2 , WRDD(M)

 9651 continue
       WRITE(4,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)


	if(ENGY.lt.0.0) then
      AAA = FUN(I,NMAR)*FUN(J,NMAR)*(RM**2 + RM/WVK +
     * 0.5/WVK**2)/(2.*WVK)
      WNN(IJ)=WNN(IJ) + AAA
	endif
      WNN(IJ)=WNN(IJ)  * 2.D0 * C1
       cs2 = cs2 + 2.d0*C1*weind

	if(prtran) 
     X  WRITE(4,229)K,LL1,JS1,L1,L2,K1,LL2,JS2,L12,L22,WNN(IJ)
	if(prtran) call flush(4)
 229   FORMAT('<',5I2,'/RO**2*COS(TETA)**2/',5I2,'> =',G12.4)
        IJ  =  IJ + 1
C        GO TO 8765
 8765 CONTINUE
C
          IJ = IJ - 1
         ASUM = A1 + A2 + A3
      ROS = DSQRT(RO2)
      WRITE(6,123)RO2,ROS,T2
      RO2M = RO2/ ASUM
      RO2MS= DSQRT(RO2M)
      WRITE(6,126 )RO2M,RO2MS,T2
C **   RLI9 = 2.32 FM
C        RA2 = 1.45D0**2
C       RA2 = 2.32D0**2
        RA2 = RCORE**2
      RO2M = A3* RA2/ ASUM + RO2M
      RO2MS= DSQRT(RO2M)
      WRITE(6,127 )RO2M,RO2MS
 123  FORMAT(5X,'RO**2=',G12.4,5X,'RO MEAN=',G12.4,' NORM=',F12.5)
 126  FORMAT(5X,'RM**2=',G12.4,5X,'RM MEAN=',G12.4,' NORM=',F12.5)
 127  FORMAT(5X,'RM**2+RCOR**2=',G12.4,5X,'RMAT MEAN=',G12.4)
C     WRITE(6,124)T4 ,T5 ,T6,T8,T9,T10
C124  FORMAT(5X,'RO2*2=',G12.4,5X,'R24 * 2=',G12.4,'RS1*2=',G12.4/
C    *       5X,'R46*2=',G12.4,5X,'R460* 2=',G12.4,'RS146*2=',G12.4/)
C
 997  FORMAT(5X,'K,L,S,L1,L2=',5I3,' RO**2=',G12.4,:,' NM:',F10.5)
C ***  COMP   RALF,RNN,RN,RAN MEAN SQUARED
        RSUM = 0.D0
      DO  5783  II = 1 , IJ
c     write(4,*) real(wnn(ii))
 5783  RSUM  = RSUM + WNN(II)
      if(prtran) write(4,*) 'DENANR:',IJ,', SUM :',RSUM
	if(prtran) call flush(4)
       write(6,1800)cs2,RO2*cs2,RSUM

 1800  format(1x,60('*')/1x,'<cos**2>',f8.3,'  ro**2*<cos**2>',f8.3,

     *  '  <ro**2*cos**2>',f8.3/1x,60('*')/)

C
C ***  N=A1=A2   R**2 = 0.5*(R1**2 + R2**2)
C
      RN2 = 0.5D0*(RO2 - RSUM*(1.D0 - A3/ASUM))/A1
      RN  = DSQRT(max(0d0,RN2))
      RAL2 = RSUM*2.D0*A1/(ASUM*A3)
      RAL  = DSQRT(max(0d0,RAL2))
      RNN2 = 2.0D0*(RO2 - RSUM)/A1
      RNN = DSQRT(max(0d0,RNN2))
      RAN2 = RSUM/A3 + RO2/(2.D0*A1)
      RAN  = DSQRT(max(0d0,RAN2))
      RALPHA = RAL * ASUM/(2d0*A1)
      RALPHA2= RALPHA**2
      ENWSR = 3.d0 * (Z3*A1/ASUM)**2 * RALPHA2 / PI
      EWSR = Z3**2/(ASUM*4d0*PI) * ryev * 18d0/A3
      WRITE(6,1272)RALPHA,ENWSR,EWSR
1272  FORMAT(5X,'Rrms=',G12.4,5X,' NEWSR=',G12.4,3X,'EWSR=',G12.4/)
      WRITE(6,753)RN2,RN,RAL2,RAL,RNN2,RNN,RAN2,RAN
 753  FORMAT(5X,60(1H*)/5X,'*  RN**2 =',G15.4,10X,'RN =',G15.4,5X,'*'/
     *                  5X,'*  RC**2 =',G15.4,10X,'RC =',G15.4,5X,'*'/
     *                  5X,'*  RNN**2=',G15.4,10X,'RNN=',G15.4,5X,'*'/
     *                  5X,'*  RCN**2=',G15.4,10X,'RCN=',G15.4,5X,'*'/
     *     5X,60(1H*)/)
	if(prtran) call flush(4)
c       prtran = .false. 

      RETURN
      END

