c ---------------------------------------------------------------
c
	Subroutine Scatter(Nstate,Nstate3,SS,alpha,VAL,VEC,
     x                     ebutc,nebut,esturm,VVsturm,phi,Rmat,AA)
	use parameters
	use globals
	use gs
	use scattering
	implicit real*8 (a-h,o-z)
	real*8 SS(nchmax,numrmax),AA(nchmax,nch),JJJ
	real*8 VAL(nchmax),VEC(nchmax,nchmax),alpha(nchmax)
	real*8 phi(MCHAN,nchmax),phib(MCHAN3),VVsturm(numrmax)
	integer nebut(MCHAN3),PRCHANG,iop(MCHAN3),KE,STR,iog(MCHAN3,2)
      	dimension ksthe(MCHAN3,LXTRA+1),ebutc(nmaxb,MCHAN3,3)
	real*8 Rmat(MCHAN3,MCHAN3),Kmat(MCHAN3,MCHAN3),
     X	       Srmat(MCHAN3*MCHAN3),Simat(MCHAN3*MCHAN3)
	real*8 CTN(MCHAN3,MCHAN3),DTN(MCHAN3,MCHAN3),PPN(MCHAN3,MCHAN3)
	real*8 f(MCHAN3*MCHAN3,2),fp(MCHAN3*MCHAN3,2),
     X        f2(MCHAN3,MCHAN3*2),fp2(MCHAN3*MCHAN3,2)
	complex*16 STIL(MCHAN3*MCHAN3)
	complex*16,allocatable:: fuh(:,:,:),trchan(:,:,:)
	real*8,allocatable:: trbas(:,:)
	logical some,esturm,natural,lallowed
	real*4 h4,e4
	data iscatt/1/

	allocate (fuh(MNOP,MCHAN3,NMAXF),trchan(MNOP,MCHAN3,nstgs))
	allocate (trbas(nstgs,nchmax))
c       ABL(R) = LOG10(MAX(ABS(R),1D-30))
C
c	PPN = projector onto non-zero norm subspace,
c	CTN = TN basis states 
c	DTN = CTN^-1
c
	eps = 1d-3
	call physp(fadex.eq.1,Nstate,wn1,MCHAN,PPN,MCHAN3,eps)
        if (prns.and.FAD) 
     X		     call printm ('PPN ',PPN,Nstate3,Nstate3,MCHAN3)
 
	call tnbasis(Nstate3,wn1,MCHAN,CTN,MCHAN3,DTN,MCHAN3,eps,NB1)
        if (FAD.and.prns)  then
	    call printm ('CTN ',CTN,Nstate3,Nstate3,MCHAN3)
            call printm ('DTN ',DTN,Nstate3,Nstate3,MCHAN3)
	   endif

c
	  KKMAX = 0
	  nos = 0
          do i=1,Nstate3
	     ksthe(i,1) = lchl(i)
	     if(ksthe(i,1).le.ktransmax) then
	       nos = nos + 1
	       iog(nos,2) = i
	       endif
	     do lx=1,LXTRA
	     	ksthe(i,lx+1) = LXTR(lx,i)
	     enddo
	  KKMAX=max(KKMAX,nint(lchl(i)+scent+1.5))
	  enddo
	PRCHANG = PARITI * PARITY
	L=2
		if(JTOT+JTOTI==0) L=0
	if(PRCHANG.lt.0) L=1
	lallowed = L .le. nint(abs(JTOT+JTOTI))
	lallowed = lallowed .and. L .ge. nint(abs(JTOT-JTOTI))
      	natural  = (-1)**nint(JTOT-JTOTI).eq.PRCHANG

!		These are just the first ones to try for:
	 STR = 1
      	 if(natural) STR = 0
	 JTR = abs(JTOT-JTOTI)
	 LTR = abs(JTR-STR)

!		For non-spin-zero ground states, try for all transititions
	if(JTOTI.gt.0.) natural = .true.
	write(6,*) 'SCATT92: JTOTI,JTOT =',JTOTI,JTOT
	write(6,*) 'SCATT92: L,lallowed,natural =',L,lallowed,natural

	  if(nbody.eq.3.and.wfs.and.strfun) then
	   call chops(28)
      	  WRITE(28,152) LTR,STR,JTR,JTOTI,PSIGN(PARITI+2),
     X			JTOT,PSIGN(PARITY+2)
152       FORMAT('# LSJ =',3I2,' for J=',f5.1,A1,' ->',f5.1,A1)
	  endif
	call chops(27)
	call chops(29)

        if(e1only.and.GO) then
c ---------------------- Calculate r^L matrix element components
	  do in=1,nstgs
	  do k=1,nch	
	    trbas(in,k) = 0d0
	  enddo
	    do irs=1,numrs1
	    r = rrade(irs)
	    rtr = r**L * PsiGSe(in,irs) * wrade(irs)
		do k=1,nch
		trbas(in,k) = trbas(in,k) + rtr*SS(k,irs*iwfskp)
		enddo
	    enddo
	  enddo
	endif
c
c		Calculate discretised response to lowest (E<EMAX) eigenstates
c
C****************************************************** B(Ek) transitions
	LSJ = 0
	print*,'Discrete?:',discrete,GO,fadex,lallowed
	if(discrete.and.GO.and.fadex.eq.1.and.lallowed) then
        print*, 'Discretised response.'
        print*, '   E       B(E',char(ichar('0')+L),') '
      	if(natural.and.(e1only.or.wfs).and.nbody.eq.3) then
*	  call chops(17)
*     	  WRITE(17,151) L,JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PARITY+2)
	endif
	   LSJ = 0
c          call conasf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	   LSJ = 0
c          call conacsf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  if(wfs.and.rtrans.gt.htrans) then
	   LSJ = 0
           call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  endif
	   nop = 1
	   iop(1) = 1 
	   some = .false.      
c			No asymptotic wave functions with discretised method
	numrso = numrs
        numrs = numrs1

	do 100 k=1,neigs
	  EE = VAL(k)
	  if(EE.gt.EMAX*2.) go to 100
		
	  if(e1only) then
	    do 41 i=1,Nstate3
	    do 41 in=1,nstgs
	     trchan(1,i,in) = 0.0
            do 41 j=1,Nstate
               T = wn1(i,j)
c              if(KFAD(i).gt.1) T = T*0.5
            if(abs(T).gt.1e-8) then
            do 40 n1=1,nsturm 
             nn1=n1+(j-1)*nsturm
40          trchan(1,i,in)=trchan(1,i,in)+VEC(nn1,k)*trbas(in,nn1)*T
	    endif
41	    continue
	  else
          do i=1,Nstate3
             do ir=1,numrs1
	     	FUH(1,i,ir)=0d0
	     enddo
	  do j=1,Nstate
	     if(abs(wn1(i,j)).gt.1e-10) then
             do n1=1,nsturm 
                nn1=n1+(j-1)*nsturm
        	do ir=1,numrs1
          	irs = ir*iwfskp
                FUH(1,i,ir)=FUH(1,i,ir)+WN1(i,j)*VEC(nn1,k)*SS(nn1,irs)
		enddo
             enddo
             endif
          enddo
          enddo
	  endif
C
      	 if(nbody.eq.3) then
         if(natural.and.lallowed) then
	   some=.true.
      	   call belmag(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,bel,bel0,L,
     x	   	      trchan,.false.,17)
c		equivalent to WRITE(17,*) EE,BEL (etc)
	   endif
c          call consf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LTR,STR,JTR)
c          call conasf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
c          call conacsf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  if(wfs.and.rtrans.gt.htrans) then

           call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ,NEMAX,0)
!           call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  endif
	 else if(nbody.eq.2) then
 	   call spbe(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,L,trchan,some,
     X			.false.)
	 endif
        if(abs(BEL).gt.1e-4) WRITE(IOUT,50)EE,bel
 50   FORMAT(F8.4,f12.6)	
100	continue
	write(6,*) ' Restoring numrs from ',numrs,' back to ',numrso
	numrs = numrso
	endif
c	
        NEMAX = (EMAX - EBEG)/abs(estep) + 1 + 0.5
       	IF(EMAX .lt. EBEG) NEMAX = 0
	if(ESCATT>1e-5) NEMAX=1
       	IF((nogscat.or.estep.lt.0).and.nccset.eq.1) NEMAX = 0
       	EGM = 0.0
       	if(NEMAX.gt.1.and..not.elinear) 
     x		EGM = (sqrt(EMAX)-sqrt(EBEG))/(NEMAX-1)
       	if(NEMAX.gt.1.and.elinear) 
     x  	EGM = (EMAX-EBEG)/(NEMAX-1)

C   Output details for Glauber calculation:
	if(wfs) then
	I  = max(NEMAX,0)
      	if(GO.and..not.GONE) I = I+1
	h4 = steps
	write(19) numrs,h4,nint(JTOT),PARITY,nos,I
	write(6,*) ' Wfs for Glauber reaction in ',(iog(i,2),i=1,nos)
	do 150 ia=1,nos
150       write(19) (ksthe(iog(ia,2),iq),iq=1,min(5,LXTRA+1))
	if(GO.and..not.GONE) then
       	  E4 = egs
       	  write(19) E4,1
       	  write(19) ((cmplx(PsiGSe(iog(I,2),N)),N=1,numrs),I=1,nos)
	  GONE = .true.
       	endif
	endif

c	if(NEMAX.le.2) go to 999
	if(NEMAX.le.0) go to 999

        print*, 'Scattering calculations:'
	bbloch = beta*Rmax
	if(abs(bbloch).gt.1e-5.and.asymp) then
	     write(6,*) ' XLR propagators assume Bbloch = 0 !'
	     stop
	    endif

c	etol = min(abs(estep)*0.5,0.01d0)
c        if(NEMAX.ge.1) write(IOUT,7000) etol
c 7000	format(/' Tolerance for avoiding R-matrix poles =',f9.5)

      	if(natural.and.(e1only.or.wfs)) then
c	  if(L.eq.1) 
     	  WRITE(10,151) L,JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PARITY+2)
	   call chops(50+L)
	  WRITE(50+L,151) L,JTOTI,PSIGN(PARITI+2),JTOT,PSIGN(PARITY+2)
151       FORMAT('# B(E',I1,') for J=',f5.1,A1,' ->',f5.1,A1)
	endif
	if(wfs.and..not.e1only) then
	  call chops(30)
      	write(30,153) rinte,JTOT,PSIGN(PARITY+2)
153	format('# Interior norms to ',f9.3,' fm for  J=',f5.1,A1)
	endif
	  if(wfs.and.strfun) then
	   LSJ = 0
          call conasf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	   LSJ = 0
          call conacsf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  endif
	  if(wfs.and.rtrans.gt.htrans) then
	   LSJ = 0
          call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	  endif
	  
	some=.false.
	phtadd = 0.0
	phtlast = 0.

C ***  LOOP AT ENERGY

      	DO 200 KE = 1, NEMAX

	if(ESCATT>1e-5) then
	   E1 = ESCATT
       	   EE = E1
	else
C                      			If points are linear in E:
       if(elinear) E1 = EBEG + EGM*(KE-1)
C                      			If points are linear in k.
       if(.not.elinear) E1 = (sqrt(EBEG) + EGM*(KE-1))**2
       EE = E1
       IF((neigs.eq.0.or.EE.gt.VAL(neigs)*0.5).and..not.simeq) then
	 write(IOUT,*) ' Highest eigenenergy ',real(VAL(neigs)), 
     &       ' does not allow scattering above 1/2 this energy'
	 write(IOUT,*) ' and not at',EE
!         go to 999
       endif
	if(.not.elinear) estp = 2*sqrt(E1)*EGM
	if(     elinear) estp = EGM
	etol = min(abs(estp)*0.75,0.01d0)
	do k=1,neigs
	   diff = E1-VAL(k)
	   if(abs(diff).lt.etol) then
		EE = VAL(k) + sign(etol,diff)
	   	write(IOUT,8000) E1,EE,k,VAL(k)
 8000	        format(/' E moved from ',F9.5,' to',f9.5,
     x             ' to avoid R-matrix pole ',i3,' at',f9.5,' MeV')
	   	E1 = EE
	    endif
	enddo
	endif
c	read(61,*)  E1
	EE = E1
	WVK  = SQRT(E1/ryev)
c				Select some typical incoming channel
	 j = 1
	 if(mintl>0) j = initl(1)
	 	cfp = 0d0
	  	do np=1,npots
	    	 cfp = cfp + cf(j,j,1,np) * potcoef(np)
   	  	enddo
         ETA = cfp / (WVK+WVK)
        RTURN =(ETA+SQRT(ETA**2 + JTOT*(JTOT+1)))/WVK
        WRITE(IOUT,8395)E1,WVK
 8395   FORMAT(/10X,'***********  E = ',F8.4,:,' K = ',F8.4,' ********')	
	if(simeq.and.KE>1) then
	  write(6,*) ' Only one energy possible with simeq method'
	  go to 200
	  endif
	if(NEMAX>1.and.RTURN>Rmax*0.5) write(IOUT,8396) JTOT,RTURN
 8396	format(' At Jtot =',f6.1,', classical turning point is',f8.2)

	call nopen2(Nstate3,EE,iop,nop,ktransmax,iog,nog)
	NB = nop
C
C****************************************************** Asymptotic forms @ Rmax
C
	call Asyuwfn(Rmax,Nstate3,EE,f,fp)
C
C****************************************************** R matrix
C
	call Rmatrix(Nstate,SS,alpha,VAL,Rmat,E1,f,fp,
     x       phi,phib,ebutc,nebut,Nstate3,esturm,VVsturm,AA)

        eigenphasesum = 0
      if(.not.asymp) then

C****************************************************** K Scattering Matrix
C
C    K =  - [G - RG~]^-1 [F - RF~] where RF~ = r R F' - r beta F, etc

	call kmatm(Nstate3,Rmax,PPN,iop,nop,f,fp,Rmat,bbloch,
     X		   Kmat)
C
	if(prkm) then
	   write(6,*) ' K matrix:'
          do 30 i=1,NOP
   30      write(6,35) i,(Kmat(i,j) , j=1,NOP)
!   30      write(6,*) i,(Kmat(i,j) , j=1,NOP)
	  endif
C****************************************************** S Scattering Matrix
C
C    S = [1 + i K] * [1 - i K]^{-1}
C
       	NFTT = 0
       	NCOL = 5
!	EE = E1
	call tmat(Kmat,Srmat,Simat,prtm,iop,nop,NFTT,
     x           nop*2,fad,CTN,DTN,NB,KFAD,STIL,NCOL,LCHL,LXTR,
     x		 fadex,MCHAN3,eigenphasesum)
      else
C************************************ Get the coupled asymptotic wave functions

	call scattx(EE,Rmax,Rmat,nop,Nstate,iop,CTN,DTN,PPN,NB,
     X		    Kmat,Srmat,Simat,STIL,wfs,
     X		    fuh(1,1,numrs1-1),steps,NR)
c
	if(wfs.and.lprwf.ge.4) then
c			Wfns and derivatives at Rmax (& maybe beyond):
	do 31 ir=numrs1-1,numrs
	 r = (max(ir,numrs1)-2)*steps
	  call chops(111)
	  call chops(112)
         write(111,315) R,(real(fuh(I,I,ir)),I=1,min(Nstate,10))
         write(112,315) R,(aimag(fuh(I,I,ir)),I=1,min(Nstate,10))
   31    continue
   32   format(f8.3,10f8.2)
	endif
	 ir = numrs1
	 if(wfs) then
c	  call chops(811)
c	  call chops(812)
c        write(811,316) EE,(real(fuh(I,I,ir)),I=1,min(Nstate,10))
c        write(812,316) EE,(aimag(fuh(I,I,ir)),I=1,min(Nstate,10))
  315   format(f8.3,1p,10e10.2)
  316   format(f8.3,1p,10f10.4)
	endif
	if(prkm) then
	   write(6,*) ' K matrix for full CC set:'
          do 33 i=1,Nstate
   33      write(6,35) i,(Kmat(i,j) , j=1,Nstate)
   35	   format(1x,i3,18f8.4,:,/(4x,18f8.4))
	  endif
      endif
C
	if(.not.(wfs.or.e1only)) go to 200
	nop1 = nop
c	call selchs(EE,iop,nop)
	nop = min(nop,MNOP)
	if(maxnop.gt.0) nop = min(nop,maxnop)
	if(nop.ne.nop1) write(IOUT,*)'    Keeping wfns in ',nop,' chs'
C****************************************************** Scattering Wavefunctions
C
	call Contwf(Nstate,Nstate3,iop,nop1,nop,EE,Srmat,Simat,f,fp,
     X             f2,fp2,SS,VAL,VEC,phi,fuh,trbas,trchan,asymp,STIL)
C
C****************************************************** B(Ek) transitions
       if(GO) then
C
      	 if(nbody.eq.3) then
      	   if(natural.and.lallowed) then
	   some=.true.
      	   call belmag(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,bel,bel0,L,
     x	   	      trchan,.true.,10)
	   endif
	  if(wfs.and.strfun) then
           call consf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LTR,STR,JTR)
           call conasf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
           call conacsf(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ)
	   endif
	  if(wfs.and.rtrans.gt.htrans) then
cbd      transition dens. for continuum
	     if(KE .eq. 1) then
		LSJ = 0
           call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ,NEMAX,1)
	     endif
           call conden(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,LSJ,NEMAX,1)

	   endif
	 else if(nbody.eq.2) then
	   call spbe(PsiGSe,EE,ksthe,Nstate3,iop,nop,fuh,L,trchan,some,
     X			.true.)
	 endif

	endif

C   Output details for Glauber calculation (even if GO)
	nog = min(nog,MNOP)
	if(maxnop.gt.0) nog = min(nog,maxnop)
	e4 = EE
	write(6,*) '  Writing ',nog,' open channels to binary file 19'
       	write(19) e4,nog
        do in=1,nog
                i = iog(in,1)
                n = (i-1)*nop1 + i   
!               diagonal element in Srmat stored as Srmat(1:nop1,1:nop)
          write(19) cmplx(Srmat(n),Simat(n))
          write(19) ((cmplx(fuh(iog(in,1),iog(i,2),n)),n=1,numrs)
     X			,i=1,nos)
	enddo


         call flush(6)
200    continue
	if(NEMAX.gt.0.and.wfs.and..not.e1only) write(30,*)'&'
	if(some) then
	   write(10,*) '&'
       	   call flush(10)
	   endif
	if(nbody.eq.3.and.wfs) then
	   write(25,*) '&'
       	   call flush(25)
	   write(28,*) '&'
       	   call flush(28)
	   endif
	if(nbody.eq.2.and.wfs) write(51,*) '&'
	if(nbody.eq.2.and.wfs) write(52,*) '&'
	 do i=1,LSJ
	   write(80+i,*) '&'
	   call flush(80+i)
	   enddo
c				Close down
999     deallocate (fuh,trchan,trbas)
	if(.not.asymp) return
	call xlrend

       return
       end
       Subroutine selchs(EEE,iop,nop)
	use globals
	use scattering
	implicit real*8 (a-h,o-z)
	integer iop(nop)
 	if(nop.le.minnop.or.turnmax.le.0.) return
c						Too many open channels
c				Trim tail-enders till first channel 
c				with turning point < turnmax
	nop1 = nop
	do 150 io=nop,minnop,-1
	i = iop(io)
	echan = EE - ecores(i)
       	WVK = sqrt(abs(echan/ryev))
	  etaq = etap/(2d0 * WVK)
          lj = lchl(i)
      	  flj = dble(lj) + scent
	if(echan.gt.0) then
          turn =(etaq+sqrt(etaq**2 + flj*(flj+1d0)))/WVK
	  if(turn.le.turnmax) go to 200
	endif
150	continue
	io = minnop
200	nop = io
	return
	end
