	module potparms
	 real*8 R0,RST,RN
     	 real*8, save,allocatable:: vk(:,:,:,:)
	 integer N,NRIN,ipf
	end module potparms
      SUBROUTINE VVREAD(NSTATE,NSTATE3,ROIN,ROSTEP,NROOO,KST)
	use globals, only: wn1,cf,numax,prns,nmom,moms,
     X			   rinner,fad,fadex,mp12,ryev,ipmax,
     X			   etap,coulcn,potcoef,npots,
     X			   kdiag,vdiag,rdiag,adiag,nidiag
	use potparms
      IMPLICIT REAL*8 (A-H,O-Z)
	real*8 vasy(NSTATE)
	logical chg
	common /io/ iin,iout

      NRIN=nint((RINNER-ROIN)/ROSTEP)+1
      WRITE(iout,21) ROIN,ROSTEP,NROOO,NRIN,
     X	 NSTATE,FAD,fadex,ipmax,NPOTS,nmom,KST
 21   FORMAT(/' VVREAD89 Initialisation: ',2F7.3,2I5,' for ',i4,' chs.',
     X  /'   Fad=',L3,', fadex=',i1,', ipmax=',i2,' npots=',I3,
     X   ' nmom=',i2,' kst=',i2)
	write(iout,*) '   Potcoefs: ',(potcoef(np),np=1,npots)
	call flush(6)
C
	if(allocated(vk)) deallocate(vk)
	allocate (vk(nstate,nstate,nrooo,npots),wn1(nstate,nstate),
     x		  mp12(nstate),cf(nstate,nstate,max(1,ipmax),npots),
     x		  moms(nstate,nstate,nmom))
         R0 = ROIN
         RST= ROSTEP
         N  = NROOO
         RN = ROSTEP*(NROOO-1) + ROIN
	 VK(:,:,:,:) = 0d0
	 CF(:,:,:,:) = 0d0
	ipf = 0
	chg = .false.
	  call chops(3)
	  open(3,access='sequential')
       DO 10 JPO1 = 1,NSTATE
	J2MIN = JPO1
	IF(FAD) J2MIN = 1
       DO 10 JPO2 = J2MIN,NSTATE
  		write(3,*) 'Try:',JPO1,JPO2,NROOO,ryev,ipmax
         DO NP=1,NPOTS
         READ(12) (VK(JPO1,JPO2,I,NP),I=1,NROOO),
     X		  (CF(JPO1,JPO2,ip,NP),ip=1,ipmax)
!  		write(3,*) 'Done',JPO1,JPO2,NROOO,ryev,ipmax
	if(NP==1.and.abs(vdiag(KST))>1e-10.and.JPO1==JPO2) then
!!			Add in any diagonal potential specified
	   do i=1,NROOO
           rr = (i-1)*RST + R0
	    T = 0.0
	    if(mod(kdiag,4)==0.and.abs(rr)>1e-3) then
	      T = vdiag(KST)/rr
	    else if (mod(kdiag,4)==1) then
	      T = vdiag(KST) / (1.0 + ddexp((rr-rdiag(KST))/adiag))
	    else if (mod(kdiag,4)==2) then
	      T = vdiag(KST) * ddexp(-(rr/rdiag(KST))**2)
	    else if (mod(kdiag,4)==3) then
	      ip = 3
              P1 = (rr/rdiag(KST))**nidiag
	      T = vdiag(KST) *P1 / (1.0 + (rr/rdiag(KST))**ip * P1)
	    endif
           VK(JPO1,JPO2,I,NP) = VK(JPO1,JPO2,I,NP) + T
	   enddo
           if(mod(kdiag,4)==3.and.ipmax>=ip) 
     x	     CF(JPO1,JPO2,ip,NP) = CF(JPO1,JPO2,ip,NP) 
     X          + vdiag(KST) * rdiag(KST)**ip
	endif
! 
	 do ip=1,ipmax
           CF(JPO1,JPO2,ip,NP) = CF(JPO1,JPO2,ip,NP)/ryev
	   if(abs(CF(JPO1,JPO2,ip,NP)).ne.0d0) ipf = max(ipf,ip)
	 enddo

           if(ipmax.eq.0) then
		CF(JPO1,JPO2,1,NP) = 0d0
	   else
	     expect = 0d0
	     if(JPO1==JPO2) expect = etap
	     chg = chg .or. abs(CF(JPO1,JPO2,1,NP)-expect).gt.1d-5
	   endif

         IF(JPO1.ne.JPO2.and..not.FAD) then
            VK(JPO2,JPO1,1:NROOO,NP) = VK(JPO1,JPO2,1:NROOO,NP)
            CF(JPO2,JPO1,1:ipmax,NP) = CF(JPO1,JPO2,1:ipmax,NP)
	 endif
	 enddo
  10   CONTINUE
       DO 20 NP=1,NPOTS
	write(3,*) 'Diagonal potentials of set ',NP,':'
       DO 15 i=1,NROOO
       rr = (i-1)*RST + R0
       write(3,25) rr,(VK(ii,ii,i,NP),ii=1,min(NSTATE,5))
15     continue
20     continue
 25     format(' R=',f8.3,' Diag V =',5f12.5)
	if(FAD) then
          DO 760 I=1,NSTATE
760       read(12) (WN1(I,J),J=1,NSTATE)
! 		write(iout,*) 'Read mp12:'
          read(12) (MP12(J),J=1,NSTATE)
	else
          DO 865 I=1,NSTATE
   	  WN1(I,1:NSTATE) = 0.0
865	  WN1(I,I) = 1.0
	endif
	  if(prns.and.FAD) then
           write(iout,*) ' N matrix:'
           do 51 i=1,NSTATE
   51      write(iout,54) i,(WN1(i,j) , j=1,i)
   54      format(1x,i3,18f7.3,:,/(4x,18f7.3))
	  endif
	do im=1,nmom
	do i=1,nstate
	read(12) (moms(i,j,im),j=1,nstate)
	enddo
	  if(prns) then
           write(iout,*) ' Moment matrix ',im
           do i=1,NSTATE
	      write(iout,54) i,(moms(i,j,im) , j=1,nstate)
	   enddo
	  endif
	enddo
c
! 	write(iout,*) 'ipmax,numax,ipf =',ipmax,numax,ipf
	numax = min(numax,ipmax)
	if(ipf < numax) then
	  write(iout,*) ' Only CF powers up to ',ipf,' found'
	  write(3,*) ' Resetting numax =',ipf
	  numax = ipf
	  endif
 	write(iout,*) 'ipmax,numax,ipf =',ipmax,numax,ipf

	do NP=1,NPOTS
	
	if(numax>=1) then
	  i = min(numax,10)
	do JPO2=1,NSTATE
	do JPO1=1,NSTATE
          	write(3,52) JPO1,JPO2,NP,ryev*CF(JPO1,JPO2,1:i,NP)
52          	format(' CF(',2i3,',:,',i2,') =',10g12.4)
	enddo
	enddo
	endif
	if(chg) then
!			Print out effective charge products if unexpected
	 write(IOUT,55) (CF(JPO1,JPO1,1,NP)*ryev/coulcn,JPO1=1,NSTATE)
55	 format(/'     Effective charge products in each channel:',/,
     X		(6x,12f6.2,:,/))
	endif

        NS = (NSTATE-1)/5 +1
        write(3,*)
        write(3,*) 'Printing channels ',(ii,ii=1,NSTATE,NS)
        call flush(3)
       DO 16 i=NROOO/2,NROOO,5
       RR = (i-1)*RST + R0
	t = 0d0
	do ii=1,NSTATE,NS
	vasy(ii) = 0d0
	rhop = 1d0/RR
	do ip=1,ipf
	 vasy(ii) = vasy(ii) + ryev * CF(ii,ii,ip,NP)*rhop
	 rhop = rhop/RR
	 enddo
	t = max(t,abs(vasy(ii)))
	enddo
16     if(T.ne.0d0) write(3,26) RR,
     X		(VK(ii,ii,i,NP)/(VASY(ii)+1d-100),ii=1,NSTATE,NS)
!     X		(VK(ii,ii,i,NP),VASY(ii),ii=1,NSTATE,NS)
26     format(' R=',f8.3,' Dg-V/asy',5f12.3)
        call flush(3)
       DO 17 i=NROOO/2,NROOO,5
       RR = (i-1)*RST + R0
	t = 0d0
	do ii=2,NSTATE,NS
	vasy(ii) = 0d0
	rhop = 1d0/RR
	do ip=1,ipf
	 vasy(ii) = vasy(ii) + ryev * CF(ii,ii-1,ip,NP)*rhop
	 rhop = rhop/RR
	 enddo
	t = max(t,abs(vasy(ii)))
	enddo
17     if(T.ne.0d0) write(3,27) RR,
     X		(VK(ii,ii-1,i,NP)/(VASY(ii)+1d-100),ii=2,NSTATE,NS)
27     format(' R=',f8.3,' o1-V/asy',5f12.3)
!	write(3,*) 'VVREAD Done'
	enddo
        call flush(3)
       RETURN
       END

C ***      POTENTIALES
      FUNCTION VVAL(IM,JM,R)
	use globals, only: cf,scent,rmax,GO,potcoef,npots,ryev,lchl
	use potparms
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(X=.16666666666667d0)
!	write(3,*) 'VVAL: ',IM,JM,R
      PP = (R - R0)/RST
      I=PP
      vval = 0.0
      if(I.ge.NRIN-3.and.I.le.NRIN-2) then
       I = NRIN-3
       go to 1
      else if(I.ge.NRIN-1.and.I.le.NRIN) then
       I = NRIN+1
       go to 1
      endif

      IF(I.LE.0) GO TO 2
    1 IF(I.GE.N-2) GO TO 4
      P=PP-I
      P1=P-1.
      P2=P-2.
      Q=P+1.
	do NP=1,NPOTS
      VVAL=VVAL + POTCOEF(NP) * (
     x	   (-P2*VK(IM,JM,I,NP)+Q*VK(IM,JM,I+3,NP))*(P*P1*X)  +    
     x      (P1*VK(IM,JM,I+1,NP)-P*VK(IM,JM,I+2,NP))*(Q*P2*.5)  )
	enddo
	go to 8
c      RETURN
    2 IF(I.LT.0) GO TO 3
      I=1
      GO TO 1
    3 VVAL = 0d0
      do NP=1,NPOTS
	VVAL=VVAL + VK(IM,JM,1,NP)*POTCOEF(NP)
	enddo
      RETURN
    4 IF(I.GT.N-2) GO TO 5
      I=N-3     
      GO TO 1   
    5 continue
	vval = 0d0
	rhop = 1d0/R
	do ip=1,ipf
	 do NP=1,NPOTS
	 vval = vval + ryev * CF(IM,JM,ip,NP)*rhop * POTCOEF(NP)
	 enddo
	 rhop = rhop/R
	 enddo
    8 if(GO.or.R*0.0.le.Rmax) return
	XKM = max(lchl(IM),lchl(JM))+scent
	FMAX = 1d5
	RHOCUT = Rmax*FMAX**(1d0/XKM)
	VVAL = VVAL * exp( -((R-Rmax)/(RHOCUT-Rmax))**2)
c		if(R.gt.Rmax.and.IM.ne.JM) VVAL = 0d0
      RETURN    
      END
C ***      POTENTIALES DERIVATIVE
      FUNCTION VVALD(IM,JM,R)
	use globals, only: cf,ryev,potcoef,npots
	use potparms
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(X=.16666666666667d0)
      PP = (R - R0)/RST
      I=PP
      vvald=0.0
      if(I.ge.NRIN-3.and.I.le.NRIN-2) then
       I = NRIN-3
       go to 31
      else if(I.ge.NRIN-1.and.I.le.NRIN) then
       I = NRIN+1
       go to 31
      endif

      IF(I.LE.0) GO TO 32
   31 IF(I.GE.N-2) GO TO 34
      P=PP-I
      P1=P-1.
      P2=P-2.
      Q=P+1.
      VVALD=0d0
	do NP=1,NPOTS
      VVALD=VVALD+ POTCOEF(NP) * (
     x	    ( -P*(3*P-4)*X*VK(IM,JM,I,NP)+
     x         (3*P*P-1)*X*VK(IM,JM,I+3,NP)  +    
     x       (3*P-1)*P1*.5*VK(IM,JM,I+1,NP)-
     x    (P*(3*P-2)-2)*.5*VK(IM,JM,I+2,NP) ) )/ RST
	enddo
      RETURN
   32 IF(I.LT.0) GO TO 33
      I=1
      GO TO 31
   33 VVALD=0d0
      RETURN
   34 IF(I.GT.N-2) GO TO 35
      I=N-3     
      GO TO 31  
   35 continue
	vvald = 0d0
	rhop = 1d0/(R*R)
	do ip=1,ipf
	 do NP=1,NPOTS
	 vvald = vvald - ip * ryev * CF(IM,JM,ip,NP)*rhop * POTCOEF(NP)
	 enddo
	 rhop = rhop/R
	 enddo
      RETURN
      END       
