      SUBROUTINE WRTMAT (A,N,M,L,NCOL)
      IMPLICIT INTEGER (A-Z)
      REAL*8 A
      COMMON /IO/ IIN,IOUT
      DIMENSION A(L,*)
*
*     WRTMAT : PRINTS AN N*M MATRIX STORED IN AN L*L ARRAY
*
      NTIM = M / NCOL
      NF = 0
      IF ( NTIM .GT. 0 ) THEN
         DO 20 I = 1, NTIM
            NI = NF + 1
            NF = NF + NCOL
            DO 10 J = 1, N
               WRITE (IOUT,1000) (A(J,K),K = NI,NF)
   10       CONTINUE
            WRITE (IOUT,1010)
   20    CONTINUE
      ENDIF
      NI = NF + 1
      IF ( NI .LE. M ) THEN
         DO 40 J = 1, N
            WRITE (IOUT,1000) (A(J,K),K = NI,M)
   40    CONTINUE
      ENDIF
      RETURN
*
c1000 FORMAT (7G16.7)
c1000 FORMAT (7F16.8)
c1000 FORMAT (8F13.8)
 1000 FORMAT (10G13.4)
 1010 FORMAT (/)
      END
      SUBROUTINE WRTMATR(A,N,M,L,NCOL,R)
      IMPLICIT INTEGER (A-Z)
      REAL*8 A,R
      COMMON /IO/ IIN,IOUT
      DIMENSION A(L,*)
*
*     WRTMAT : PRINTS AN N*M MATRIX STORED IN AN L*L ARRAY
*
      NTIM = M / NCOL
      NF = 0
      IF ( NTIM .GT. 0 ) THEN
         DO 20 I = 1, NTIM
            NI = NF + 1
            NF = NF + NCOL
            DO 10 J = 1, N
               WRITE (IOUT,1000) (R*A(J,K),K = NI,NF)
   10       CONTINUE
            WRITE (IOUT,1010)
   20    CONTINUE
      ENDIF
      NI = NF + 1
      IF ( NI .LE. M ) THEN
         DO 40 J = 1, N
            WRITE (IOUT,1000) (R*A(J,K),K = NI,M)
   40    CONTINUE
      ENDIF
      RETURN
*
c1000 FORMAT (7G16.7)
 1000 FORMAT (7F16.8)
 1010 FORMAT (/)
      END
