      module xlrmod
     	PARAMETER (LWRAN1=5000)
 	real*8,save,allocatable:: ethr(:)
!	real*8,save,allocatable:: ethr(:)
	real*8 RSTEPLW,BBLOCH,E0,RAFIN1,LWSECT(LWRAN1)
        integer	NMATR,LMAX,NFINAL,
     X		LWRAN,LWKEEP(LWRAN1),KEEP(LWRAN1),LWGF(LWRAN1)
	logical WFIN
      end module xlrmod
      SUBROUTINE XLRIN (RMATR,NC,BLOCH,WFNRM,STEP,NR)
	use globals, betas=>beta, stepp=>step
	use xlrm, beta=>betalw
	use pauli
	use scattering
	use xlrmod
      IMPLICIT INTEGER (A-Z)
      LOGICAL SYMML,LDEBUG,WFNRM
      REAL*8 RMAT, ABOUND, STEP,EIG,WMAT, SRMAT,SIMAT,KMAT,
     X                 EBMIN, EBMAX, EEE,
     X                 BLOCH, RMATR, SCALX,RSCALX,PSI,EBND,
     X		       CTN,DTN,PPN,FACMIN,DLAMCH
	COMPLEX*16 WFN,STIL(NOP,NOP)
      PARAMETER ( FACMIN = 1.0D+15)
      DIMENSION EIG(NS),KMAT(NC*NC),SRMAT(NOP,NOP),SIMAT(NOP,NOP),
     X          WMAT(NC*NS), RMAT(NC*NC), ABOUND(NS),CTN(MCHAN3,MCHAN3),
     X		IOP(NC),DTN(MCHAN3,MCHAN3),PPN(MCHAN3,MCHAN3)
      DIMENSION WFN(MNOP,MCHAN3,NR+1),PSI(MCHAN,NR+1)
      COMMON /MACH/ SCALX,RSCALX
      COMMON /XPROP/ SYMML,NSURF
*
c     ENTRY XLRIN
      E0 = 0d0
      SYMML = SYMM
      SCALX = 1d0
      SCALX = FACMIN * DLAMCH('S')
      SCALX = sqrt(SCALX)
      RSCALX = 1d0 / SCALX
	write(3,*) ' With DLAMCH(''S'') =',DLAMCH('S')
	write(3,*) ' Using RSCALX =',RSCALX

	BBLOCH = BLOCH
	nopp = -1
        SYMM = .not.FAD
      WRITE (IOUT,1112) RMATR,BBLOCH
	IF (RAFIN.lt.RMATR) RAFIN = RMATR
	RAFIN1 = RAFIN
	PROP = RAFIN.gt.RMATR
	WFRMAX = RMATR+ (NR-1)*STEP
	WFIN = STEP.gt.0d0 .and. NR.gt.1
	RSTEPLW = 0d0
	if(WFIN) RSTEPLW = STEP
c	write(6,*) ' RMATR,RAFIN,WFRMAX,NR =',RMATR,RAFIN,WFRMAX,NR
	write(6,*) ' So PROP,WFNRM,WFIN =',PROP,WFNRM,WFIN
	write(6,*) ' as RSTEP,NR =',STEP,NR
      IF(WFIN) WRITE (IOUT,1113) STEP,WFRMAX

	allocate (ETHR(NC))
      CALL CPARM (NC,ECORES,LCHL,ETHR,E0,ryev,.true.)
! 	write(6,*) 'xlrin2: nc,ethr:',nc,ethr
*
*
      LMAX = MAXL(NC,LCHL)
      IF (PROP) THEN
         IRECL = 2 + NC + 3 * NC*NC
         IRECL = IRECL * 8
         OPEN (IDISCR,FILE = FLWP,ACCESS = 'DIRECT',
     X        RECL = IRECL,STATUS = 'UNKNOWN')
         OPEN (IDISCR+1,FILE = FLWPR,FORM = 'UNFORMATTED',
     X        STATUS = 'UNKNOWN')
         WRITE (IOUT,1111) BETA
         NSTART = 1
         LWRAN = LWRAN1
	  write(3,*) ' Call SLWPOT with NC,RMATR,BETA,NUMAX='
	  write(3,*)  NC,RMATR,BETA,NUMAX
         NMATR = NSTART
         CALL SLWPOT (NSTART,NC,NC,
     X                PRNTV,DEBUG,RMATR,RAFIN,LWSECT,LWKEEP,LWRAN,
     X                BETA,CUPLIM,NUMAX,
     X                LCHL,CF,MCHAN,ETHR,IDISCR,DEBUG,
     X		      STEP,WFRMAX,LWGF,SYMM,NBLOCK,EFERMI)
	 NFINAL = NSTART
      ENDIF
      WRITE (IOUT,1060) RAFIN,IASY,APEPS,DEGENY,APFLG
      WRITE (IOUT,1105) EWRON,DEPLIM,CUPLIM
      RETURN
*
*		Now for bound state searching
*
      ENTRY BOUNDX(RMATR,RMAT,NC,NS,EIG,WMAT,
     X                 PSI,STEP,NR,ABOUND,NPOLE,EBND)
	NSURF = NC
	RAFIN = RAFIN1
        CALL CPARM (NC,ECORES,LCHL,ETHR,E0,ryev,.true.)

         CALL BOUNDC (NC,ETHR,NS,MGVN,GUTOT,ABOUND,EBND,PSI,NR,
     X                LCHL,CF,MCHAN,BBLOCH,PRBC,LMAX,
     X                EBMAX,EBMIN,EIG,WMAT,E0,RMAT,NPOLE,
     X                ECORES,RAFIN,RMATR,RMATR,PRWR,PRWF,LWSECT,
     X                APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                PROP,KEEP,LWRAN,IDISCR,LWKEEP,PRNTR,DEPLIM,
     X                NFINAL,LWGF,WFIN,STEP)
	RETURN
*
*		Now for each scattering energy
*
      ENTRY SCATTX(EEE,RMATR,RMAT,NOP,NC,IOP,CTN,DTN,PPN,NB,
     X                 KMAT,SRMAT,SIMAT,STIL,WFNRM,WFN,STEP,NR)
c	write(6,*) ' LAST reset to',LAST
	write(3,*) 'PRRM,PRKM,PRTM,PRWF =',PRRM,PRKM,PRTM,PRWF
        CALL CPARM (NC,ECORES,LCHL,ETHR,E0,ryev,.true.)
! 	write(6,*) 'scatt: nc,ethr:',nc,ethr
	RAFIN = RAFIN1
	NSURF = NC
	LDEBUG = .false.
	if(MSURF.gt.0) then
	   NSURF = min(MSURF,NC)
	   write(6,*)'  Propagating only ',NSURF,' adiabatic states'
	   endif
c	write(3,*) ' RAFIN reset to',real(RAFIN)

         CALL PHASED (EEE,NC,NOP,BETA,CUPLIM,ETHR,
     X                E0,ECORES,RMAT,PRRM,PRNTV,LDEBUG,
     X                PRWF,EBMAX,EBMIN,LWSECT,
     X                LCHL,LMAX,CF,MCHAN,BBLOCH,RAFIN,
     X                PRWR,.true.,PRKM,KMAT,PRTM,NFTT,
     X		      SRMAT,SIMAT,IOP,CTN,DTN,NB,KFAD,FAD,fadex,
     X                APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                PROP,KEEP,LWRAN,IDISCR,LWKEEP,PRNTR,DEPLIM,
     X		      NMATR,RMATR,WFIN,WFNRM,WFN,MNOP,NR,MCHAN3,
     X                RSTEPLW,NFINAL,LXTR,LWGF,PPN,STIL,
     X		      RAFIN1,MAXTRY,RFACT,RAFIX,GFACT,
     X		      NBLOCK,EFERMI) 
c     ENDIF
c	endif
      RETURN
      ENTRY XLREND
	  CLOSE (IDISCR,STATUS='delete')
          CLOSE (IDISCR+1,STATUS='delete')
	  deallocate (ETHR)
      RETURN
*
 1060 FORMAT (' RAFIN  =',F12.4,' IASY =',I3,' APEPS =',F10.6,
     X        ' DEGENY =',F10.6,/,' APFLG =',5I3)
 1105 FORMAT (' EWRON  =',1P,D10.2,0P,'     DEPLIM =',F10.4,
     X        '  CUPLIM =',1P,D10.2)
 1110 FORMAT (' DEPLIM increased by',D11.2,' to',F9.4,' (',F9.3,' MeV)')
 1111 FORMAT (' BETALW =',1P,E10.2)
 1112 FORMAT (' RMATR  =',F12.6,'  BBloch =',f12.6)
 1113 FORMAT (' RSTEPS =',F10.6,'  WFRMAX =',F12.6)
      END
      SUBROUTINE PHASED (EE,NC,NOP,BETA,CUPLIM,ETHR,
     X                   E0,ECORES,RMAT,PRRM,PRNTV,LDEBUG,
     X                   PRWF,EBMAX,EBMIN,LWSECT,
     X                   LCHL,LMAX,CF,MCHAN,BBLOCH,RAFIN,
     X                   PRWR,KM,PRKM,KMAT,PRTM,NFTT,
     X                   SRMAT,SIMAT,IOP,CTN,DTN,NB,KFAD,FAD,fadex,
     X                   APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X                   PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X                   NMATR,RMATR,WFIN,WFNRM,WFN,MNOP,NR,MCHAN3,
     X                   RSTEP,NFINAL,LXTR,LWGF,PPN,STIL,
     X		         RAFIN1,MAXTRY,RFACT,RAFIX,GFACT,
     X			 NBLOCK,EFERMI) 
      IMPLICIT INTEGER (A-Z)
      LOGICAL PRRM,PRWR,PRWF,PRKM,PROP,PRTM,PRNTV,LDEBUG,
     X        DEBUG,KM,WFNRM,WFIN,FAD
      REAL*8 RMAT,CF,E0,ECORES,RMATR,EBMAX,EBMIN,E,EEE,BETA,
     X       EE,HALF,BBLOCH,F,FP,ET,APEPS,RAFIN,
     X       DEGENY,EWRON,KMAT,X,ETHR,SRMAT,SIMAT,A,C,CUPLIM,
     X       DEPLIM,WRERR,LWSECT,RMATO,AM,RSTEP,PPN,CTN,DTN,
     X 	     RAFIN1,RFACT,RAFIX,GFACT,RADIUS,EFERMI
	COMPLEX*16 WFN,STIL(NOP,NOP)
      PARAMETER ( HALF=0.5D0)
      COMMON /IO/ IIN,IOUT
      COMMON /IE/ EEE,IERR
      real*8 scent,ryev
      common /cent/ scent,ryev
      DIMENSION 
     X	ET(nc),RMAT(nc*nc),LCHL(nc),CF(nc*nc*numax),RMATO(nc*nc),
     X	RADIUS(MAXTRY),ECORES(nc),KMAT(nc*nc),KFAD(nc),
     X	CTN(MCHAN3,MCHAN3),
     X	F(nc*nc*4),FP(nc*nc*4),ETHR(nc),PPN(nc*nc),
     X	LWSECT(LWRAN),LWGF(lwran),DTN(MCHAN3,MCHAN3),IOP(*),
     X	LWKEEP(LWRAN),KEEP(LWRAN),APFLG(5),LXTR(6,nc),
     X	SRMAT(NOP,NOP),SIMAT(NOP,NOP),WFN(MNOP,MCHAN3,NR+1)
*
      IERR = IOUT
         E = EE / RYEV
c       write(IOUT,*)
c   	write(IOUT,*) 'Energy ',real(EE)
    	write(3,*) '---------------------------------------------'
    	write(3,*) 'Energy ',real(EE)
c	write(IOUT,*)
         DO 10 I = 1, NC
            ET(I) = E - ETHR(I)
   10    CONTINUE
         IF (PRRM.and.PRWF) THEN
c        IF (PRRM) THEN
            if(NOP.lt.NC) WRITE (IOUT,1010) NOP
            WRITE (IOUT,1020) RMATR
c           CALL WRTMAT (RMAT,NC,NC,MCHAN3,NCOL)
            CALL WRTMATR(RMAT,NC,NC,MCHAN3,NCOL,RMATR)
         ENDIF

          CALL DCOPY (MCHAN3**2,RMAT,1,RMATO,1)

c		Now propagate RMAT from RMATO @ RMATR to RAFIN, outwards.
	   write(3,*) ' Now ASYMS ',real(RMATR),' to ',real(RAFIN)
	   write(3,*) ' Now ASYMS 1 to ',NMATR
         CALL ASYMS (E,RMAT,KM,KMAT,NC,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,
     X               LMAX,IOP,NOP,RAFIN,RMATR,PRRM,PRWR,PRWF,PRKM,WRERR,
     X               APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X               PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X               LWSECT,NMATR,NFINAL,WFIN,LWGF,PPN,MCHAN3,
     X		     RMATO,RAFIN1,RADIUS,MAXTRY,RFACT,RAFIX,GFACT,
     X               PRNTV,LDEBUG,BETA,CUPLIM,ETHR,FAD,NBLOCK,EFERMI)

         CALL TMAT(KMAT,SRMAT,SIMAT,PRTM,IOP,NOP,NFTT,
     X       	NOP*2,FAD,CTN,DTN,NB,KFAD,STIL,NCOL,LCHL,LXTR,fadex,
     X		MCHAN3)
c	endif
	  if(.not.WFNRM) go to 100

	   write(3,*) ' Call ASYMO at r=',real(RAFIN),NFINAL,
     X			' in to ',real(RMATR),NMATR
C
C  Now, ASYMO will replace F(*) by H(-) - H(+).S, the regular solution,
C       and then apply the global R-matrix propagation in from RAFIN to RMATR
C	with stabilisation from the RMAT at RMATR
C
         CALL ASYMO (E,RMATO,KM,KMAT,NC,LCHL,CF,MCHAN,BBLOCH,F,FP,ET,
     X               LMAX,NOP,RMATR,RAFIN,PRRM,PRWR,PRWF,PRKM,WRERR,
     X               APFLG,APEPS,IASY,DEGENY,NUMAX,EWRON,NCOL,
     X               PROP,KEEP,LWRAN,IDISCR,LWKEEP,DEBUG,DEPLIM,
     X               LWSECT,NMATR,NFINAL,WFIN,LWGF,
     X		     WFN,MNOP,NR,MCHAN3,RSTEP,SRMAT,SIMAT)

  100 CONTINUE
      RETURN
*
 1010 FORMAT ( ' NOPEN =',I3)
 1020 FORMAT (' INITIAL R-MATRIX AT  R  =',F9.5,' A.U. :')
      END
