	Subroutine Basis(Nstate,SS,alpha,VVsturm,UseAlpha,ebutc,nebut,
     & 			  Nstate3,esturm,failed)
	use globals
	use scattering
        implicit real*8 (a-h,o-z)
	real*8 VVsturm(numrmax),Wws(numrmax+1),Wso(numrmax+1),D1(Nstate)
	real*8 SS(nchmax,numrmax),S(numrmax),alpha(nchmax)
	real*8 Psi0(numrmax+1),logd,ebutc(nmaxb,MCHAN3,2),lagnorm
        real*8 AA(Nstate,Nstate),VAL(Nstate),VEC(Nstate,Nstate)
	logical failed(nchmax),UseAlpha,esturm,anyfail
        integer SCON,PCON,nebut(MCHAN3)

	esturm = mod(kind,nkind).ne.2
	nfile=160
          if(pralpha) call chops(2)
          if(pralpha) call chops(4)
	  if(prbut) call chops(1)
	  if(prbut) call chops(31)
	failed(:) = .false.
	anyfail=.false.
        H2SM=1.d0/rmt
	Vmin = -100.
	Rex0 = 1.0
c					This line is odd!:
c	beta = -sqrt(-Eo(kst)/ryev)
c					should be?
	beta = -sqrt(abs(Eo(kst))/ryev)
c         beta = sign(beta,Eo(kst))
          do i=1,numr
	    r = rrad(i)
	    if(mod(kind,nkind).eq.0) then
	     sm = 1.0 - ddexp(-((r-rrad(numr))/Rex0)**2)
	     VVsturm(i)=max(Vmin,Vsturm/(r)) * sm
	    else if(mod(kind,nkind).eq.1) then
 	     VVsturm(i)=Vsturm/(1+Exp((r-RRsturm)/asturm))
	    else if(mod(kind,nkind).eq.2) then
c            will get potential for each channel
	    else if(mod(kind,nkind).eq.3) then
 	     VVsturm(i)=-1.0
	    else if(mod(kind,nkind).eq.4) then
c 	     will  read in from file 36
	    else if(mod(kind,nkind).eq.5) then
	     sm = 1.0 - exp(-((r-rrad(numr))/Rex0)**2)
	     VVsturm(i)=max(Vmin,Vsturm/(r)**3) * sm
	    else if(mod(kind,nkind).eq.6) then
C		will find r-eigenvalues
	    endif
	  enddo
	if(mod(kind,nkind).eq.4) then
	  write(6,*) ' Reading Sturmian potential from file 36'
	  read(36,*) 
	   Rex0 = rrad(numr)*0.25
	  do i=1,numr
	   read(36,*) r,U
	   sm = 1.0 - exp(-((r-rrad(numr))/Rex0)**2)
	   VVsturm(i) = min(U,0d0) * sm
	   if(abs(r-rrad(i)).gt.1e-5) then
	    write(6,*) ' VVsturm from file 36 was for different'
     x		,' radial grid!',r,rrad(i)
	    endif
	    call chops(40)
 	    write(40,*)  real(rrad(i)),VVsturm(i)
	  enddo
	  read(36,*) 
	else if(mod(kind,nkind).eq.6) then
	   call chops(41)
	  do ir=1,numr
	  r = rrad(ir)
	   do i=1,Nstate
	    cen = H2SM*(LCHL(i)+scent)*(LCHL(i)+scent+1)/r**2
	   do j=1,Nstate
	    AA(i,j) = VVAL(i,j,r)
	    enddo
	    AA(i,i) = AA(i,i) + cen
	    enddo
C Ax=Ex all
	   call F02ABF(AA,Nstate,Nstate,VAL,VEC,Nstate,D1,IFAIL)
	  cen = H2SM*(LCHL(1)+scent)*(LCHL(1)+scent+1)/r**2
	   VVsturm(ir) = min(VAL(1) - cen , 0d0)
           write(41,1654) rrad(ir),VVsturm(ir),
     x                     (VAL(i),i=1,min(Nstate,8))
 1654    format(1X,F7.3,2X,9G11.3)
	   enddo
	endif
        PCON=0
	if(pralpha) PCON=4
        NCMAX=numrmax
	   UOLD = 1.; EIGOLD=0.
        do k=1,nch
	  kh=(k-1)/nsturm+1
	  nodes=k-((k-1)/nsturm)*nsturm
	  nodes1 = nodes
	  BE=-Eo(kst)+ecores(kh)
	  BE=-Eo(kst)
C------------------------------------------- STURMIANS
	if(sturm(kst).eq.'T') then
          SCON=1 
	  BE=-Eo(kst)+ecores(kh)
          do i=1,numr
	    r = rrad(i)
	    if(mod(kind,nkind).eq.2) VVsturm(i)=VVAL(kh,kh,r)

	    if(nodes.eq.1.and.kind.ge.nkind) then
 	       Vef=VVsturm(i)+H2SM*
     &           (LCHL(kh)+scent)*(LCHL(kh)+scent+1)/(r)**2
 	       write(40,*) r,VVsturm(i),Vef
	    endif
            Wws(i)=rmt*VVsturm(i)
	    Wso(i)=0
          enddo
            Wws(numr+1)=0.
	    Wso(numr+1)=0.
          if(nodes.le.1) U=1.d0
          if(nodes.ge.4) U=U*(dble(nodes)/dble(nodes-1))**1.25
	  if(UseAlpha.and.alpha(k).ne.0.) U = alpha(k)
	  cen = LCHL(kh)+scent
	  if(pertcent) cen = scent
          NCMIN=nint(max(cutl*cen,cutr/step))+1
	  IFAULT=0
          call SEARCH8(nodes,cen,numr,step,H2SM,U,BE,
     X       Wws,Wso,S,SCON,PCON,IFAULT,NCMIN,NCMAX)
	else if(sturm(kst).eq.'F') then
C------------------------------------------- ENERGY EIGENSTATES
	  do i=1,numr
		if(esturm) then
            	  Wws(i)=rmt*VVsturm(i)
!           	  write(41,1654) rrad(i),VVsturm(i)
		else	
            	  Wws(i)=rmt*VVAL(kh,kh,rrad(i)) * 1.0
		endif
	    Wso(i)=0
	  enddo
            Wws(numr+1)=0.
	    Wso(numr+1)=0.
C beta = logarithmic derivative of basis functions at Rmax
          SCON=2
	  U = 1d0
          if(nodes.le.3) EIG = 0.0
          if(nodes.ge.4) EIG = 2*alpha(k-1)-alpha(k-2)
	  if(UseAlpha.and.alpha(k).ne.0.) EIG = alpha(k)
	  cen = LCHL(kh)+scent
	  if(pertcent) cen = scent
          NCMIN=nint(max(cutl*cen,cutr/step))+1
	  IFAULT=0
          if(pralpha) write(2,*) 'Beta =',real(beta)
          call SEARCH9(nodes,cen,numr,step,H2SM,U,EIG,beta,
     X       Wws,Wso,S,SCON,PCON,IFAULT,NCMIN,NCMAX)
	else if(sturm(kst).eq.'L') then
C------------------------------------------- L=0 GAUSS-LAGUERRE
	n = nodes-1
	xn = lagnorm(n,alf)
        do i=1,numr
	  U = rrad(i)/step
	  S(i) = polag(n,alf,U)* xn * U**(alf*0.5) * exp(-U*0.5)
          enddo
	beta =dlagn(n,alf,rmax/step)/step/S(numr) 
	IFAULT = 0
	endif
C-------------------------------- common case:
	  if(IFAULT.ne.0) then
	   failed(k) = .true.
!	   anyfail = .true.
           write(6,*) 'n,k,l: ',nodes,kh,lchl(kh)+real(scent),
     X        '  IFAULT,EIG,U: ',IFAULT,real(EIG),real(U)
 	   EIG = EIGOLD  ! last successful, use as next starting point
 	   U = UOLD
	   S(:) = 0.
	  else
	   UOLD = U; EIGOLD=EIG
	  endif

          do i=1,numr
            SS(k,i)=S(i)
          enddo
	  if(nodes1.eq.1) nfile=nfile+1
	    if(prsturm) then
		call chops(nfile)
 	        write(nfile,*)  '#  CHANNEL ',kh,' with ',nodes,' nodes'
          	do i=1,numr
 	    	write(nfile,30) real(rrad(i)),S(i)
30		format(f9.4,g14.5)
          	enddo
	        write(nfile,*)  '&'
	    endif
          if(sturm(kst).eq.'T') alpha(k)=U
          if(sturm(kst).eq.'F') alpha(k)=EIG
	  if(pralpha.and..not.glag) then
 	     if(nodes1.eq.1) write(4,*)  '&'
 	     if(nodes1.eq.1) write(4,*)  '#  CHANNEL ',kh
 	     write(4,*)  nodes1,real(alpha(k)),real(S(numr))
c            write(102,*) 'DR',real(beta)
c    x            ,real(deriv(SS,nchmax,k,numr,step)/SS(k,numr))
c    x            ,real((SS(k,numr)-SS(k,numr-1))/step/SS(k,numr))
	  endif
        enddo
        call flush(3)
!        call flush(4)
!	if(anyfail) stop
	if(buttle.le.0) return
C****************************************************** Buttle Correction
!	write(6,*) 'Buttle corrections'
	do 60 j=1,Nstate3
!		write(6,*) '60: j =',j
	i = j
	if(icop(j).ne.0) i = icop(j)
c
	nn = 0
	do 40 n1=1,nsturm
	   k = (i-1)*nsturm + n1
	   if(alpha(k).lt.0.) go to 40
	   if(nn.eq.0) E1 = 0.0
	   if(nn.gt.0) E1 = alpha(k-1)
	               E2 = alpha(k)
	   do 35 ib=1,buttle
c			     pick energy ib/(buttle+1) of range E1->E2
	   if(nn.ge.nmaxb) go to 35
	   nn = nn + 1
	   EE = E1 + (E2-E1) * dble(ib)/dble(buttle+1)
	   ebutc(nn,j,1) = EE
  35	   continue
  40	   continue
	nebut(j) = nn
	if(EE.lt.emax) then
	write(6,41) EE,emax
  41	format(/' ONLY ENOUGH ROOM for table of Buttle corrections',
     x          ' to',F8.3,', and scattering to',f8.3,' MeV reqd')
c		stop
	endif

	do 50 nn=1,nebut(j)
	E1 = ebutc(nn,j,1)

c	Calculate exact wave function for e.g. diagonal potential

	  cen = LCHL(j)+scent
	  if(pertcent) cen = scent
	call integ3(i,cen,numr,stepi,ryev,E1/ryev,Psi0,logd,
     X		    esturm,VVsturm)

	Rmat0 = 0.0
          do 45 n=1,nsturm
	  k = (i-1)*nsturm + n
	  if(eeigmax.gt.1..and.alpha(k).gt.eeigmax) go to 45 
         Rmat0 = Rmat0 + ryev*SS(k,numr)**2/(alpha(k)-E1)/Rmax
  45     continue
C
c	if(prbut) write(2,*)  ' Uncoupled ch.',j,' beta =',real(beta)
	Rex0 = 1d0/(Rmax*(logd - beta))

	ebutc(nn,j,2) = Rex0 - Rmat0

	if(prbut)
     x	write(1,48) E1,j,Rex0,Rmat0,ebutc(nn,j,2)
   48   format(' E,ch =',f8.4,i3,' Rex0,Rmat0=',2f10.5,' =>+',2f10.5)
	if(prbut) write(31,65)  E1,ebutc(nn,j,2)
   50   continue
	if(prbut) write(31,*)  '&'
   60   continue
   65   format(f8.4,10f10.6)
	return
	end
