      SUBROUTINE BELMAG(FUL,EC,KSTHE,NSTHE,IOP,NOP,FUH,BEL,BEL0,LL,
     x			TRCHAN,CONT,NFI)
	use parameters
	use globals
	use gs
	use scattering
      IMPLICIT real*8 (A-H,O-Z)
C    ***********************************************************
C  CALCULATION OF B(E0,1,2) AS A FUNCTION OF KINETIC ENERGY OF REACTION
C  PRODUCTS
C
C         FOR 3-BODY CONTINUUM
C
C    ***********************************************************
C *** K,L,S,L1,L2,2*S1,2*S2 - QUANTUM NUMBER    IN ARRAY
      DIMENSION KSTHE(MCHAN3,7)
      COMPLEX*16 FUH,TRCHAN(MNOP,MCHAN3,nstgs),
     X	SUMCHS(MCHAN3,nstgs,MNOP)
      DIMENSION FUL(nstgs,NMAXF),FUH(MNOP,MCHAN3,NMAXF)
      DIMENSION     SUMI(MCHAN3), SUMR(MCHAN3)
      DIMENSION    SUMI1(MCHAN3), SUMR1(MCHAN3),IOP(NOP)
      INTEGER PHASE
      LOGICAL CONT,PR
	real*8 KTARG,JLI,JHE
        Z = 0d0
        Z = 0d0
C    ***********************************************************
C                       Some physics input we need:
      S1 = 0.5D0
      S2 = 0.5D0
!				Get information from globals for local use:
!				DENANR assumes 1,2 are nucleons, 3 is core!
	A1 = mass(1)
	A2 = mass(2)
	A3 = mass(3)
	Z3 = charge(3)
	Q0CORE = Qmom(3)
	KTARG = CoreK(3)
C########################################################### for STURMX:
      NM = numrs
      H = steps
	if(glag) NM = numr
      RM = NM*H
      IMAX = NM

      IMAGS = numgs
      HGS = stepgs
      RMGS = IMAGS*HGS
      if(prtran) then
      call chops(4)
      write(4,*) 'BELMAG: E =',real(EC)
      write(4,*) 'BELMAG: RM,H,IMAX,iwfskp=',
     X           real(RM),real(H),IMAX,iwfskp
      write(4,*) 'BELMAG: RMGS,HGS,IMAGS=',
     X           real(RMGS),real(HGS),IMAGS
      write(4,*) 'BELMAG: multipliers=',mult
      endif
	 I = 2
	IO = 1
	IF = 1
C######################################################################
        do io=1,nop
	 JFK=iop(io)
	if(KFAD(JFK).eq.1) NOP1 = JFK
	enddo
C######################################################################
C                 XAP IN 1/FERMI
C    *******************************************************************
       XAPL =0.21954D0*DSQRT(DABS(EGS))
       XAP=0.21954D0*DSQRT(ABS(EC))
c      write(4,*) 'GS E,K:',EGS,XAPL,'; continuum:',EC,XAP
       DEN=0.21954D0**2*0.5D0
          ASUM = A1 + A2 + A3
      AL2 = 1.D0/(4.D0*3.14159D0)*Z3**2*((A1+A2)/(ASUM*A3))**2
      AL1 = 1.D0/(4.D0*3.14159D0)*Z3**2*((A1+A2)/(ASUM*A3))
      AL20 = 1.D0/(4.D0*3.14159D0)
      WFN = 1.D0/(2.D0*3.14159D0)
CC
C ***   IE - MULTIPOLARITY OF TRANS
       IE = LL
        if(prtran) WRITE(4,151) IE,e1only
  151 FORMAT(3X,'B(E',I1,')   CALCUL. BEGINS ',L1,/)
	JLI = JTOTI
	JHE = JTOT
C
      IF(IE .EQ. 0.and..not.e1only) GO TO 1000
      IF(IE .EQ. 1) GO TO 2000
      IF(IE .EQ. 2) GO TO 3000
         GO TO 4000
C
C  ***  MONOPOLE TRANS
C
C   *** NUCLEAR RESPONSE  RO**2  ****
C
 1000      RSUMBO=0.D0
            DO I = 1,MCHAN
      SUMI(I) = 0.D0
      SUMR(I) = 0.D0
            END DO
C ****  LOOP ON HYPERIMPULS Q. NUMBERS
          DO 6 IO=1,NOP1
	     JFK=IOP(IO)
	  if(KFAD(JFK).ne.1) go to 6
      ASUMBO=0.D0
      RSUMMA=0.D0
      ASUMMA=0.D0
      RSUM=0.D0
      ASUM=0.D0
C *****  HYPERRADIUS M.E. SUM
        DO 1 J1=1,NSTHE
        if(prtran) write(4,94) 'K1,L,S,l1,l2,Jn,ii:',
     X			(KSTHE(J1,i)/MULT(i),i=1,7)
          DO 2 J2=1,NSTGS
	  if(KFAD(J1).ne.1) go to 2
	  if(KFADGS(J2).ne.1) go to 2
      IF(KSTHE(J1,1).NE.KSTGS(J2,1)) GO TO 2
      IF(KSTHE(J1,2).NE.KSTGS(J2,2)) GO TO 2
      IF(KSTHE(J1,3).NE.KSTGS(J2,3)) GO TO 2
      IF(KSTHE(J1,4).NE.KSTGS(J2,4)) GO TO 2
      IF(KSTHE(J1,5).NE.KSTGS(J2,5)) GO TO 2
      IF(KSTHE(J1,7).NE.KSTGS(J2,7)) GO TO 2
        if(prtran) write(4,94) 'K2,L,S,l1,l2,Jn,ii:',
     X			(KSTHE(J2,i/MULT(i)),i=1,7)
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(
     x 	  	   KSTGS(J2,2)/MULT(2)+KSTGS(J1,3)/MULT(3)-JTOTI +
     X		   KSTHE(J2,2)/MULT(2)+KSTHE(J1,3)/MULT(3)-JTOT)
	endif
C
C  ***  RADIAL MATRIX ELEMENTS
C
 3    RSU = 0.D0
      ASU=0.D0
C
      DO 5 I=1,IMAX
C
         R2 = rrade(I)**2
	 H  = wrade(I)
C
        IF(I.lt.IMAGS) then
            FULLL = FUL(J2,I)
           else
            R12 = H*I
            FULLL = FUL(J2,IMAGS)*DEXP(XAPL*(RMGS-R12))
           endif
         RSU       = H * REAL(FUH(IO,J1,I))*FULLL*R2 +RSU
         ASU       = H * AIMAG(FUH(IO,J1,I))*FULLL*R2 +ASU
      RSU1       =REAL(FUH(IO,J1,I))*FULLL*R2
      ASU1       =AIMAG(FUH(IO,J1,I))*FULLL*R2
      rsu2       =REAL(FUH(IO,J1,i))
      asu2        =AIMAG(FUH(IO,J1,i))
 5    CONTINUE
       if(prtran) write(4,*)'E0 NUCL, K',rsu,asu,ksthe(j1,1)
C
C  *** PARTIAL
C       SUMR(J1) = AL2*(RSU**2 + ASU**2)*XAP**4*0.5D0*0.21954D0
	RSU = RSU*PHASE
	ASU = ASU*PHASE
      RSUMMA=RSUMMA+RSU
      ASUMMA=ASUMMA+ASU
C  ARRAY OF K-PART DATA
C
C      WRITE(4,100) (KSTGS(J2,M21),M21=1,7),(KSTHE(J1,M1),M1=1,7)
C     *,RSU,ASU
C 100  FORMAT(1X,' < 6GS ',7I3,' /MGT/ Cont ',7I3,' > =',2G12.4)
C
 2    CONTINUE
 1    CONTINUE
C
      SUMR(IO) = RSUMMA
      SUMI(IO) = ASUMMA
C
 6    CONTINUE
C
            ESUM = 0.D0
          DO I = 1,NOP1
	   IF(KFAD(I).eq.1) then
            SUMR(I) =AL20*(SUMR(I)**2+SUMI(I)**2)
            if(CONT) SUMR(I) =SUMR(I)*DEN*WFN/XAP
            ESUM = ESUM + SUMR(I)
	   endif
           END DO
C
      BEL0  = ESUM
C
C      BEL0  = AL20*(RSUMMA**2 + ASUMMA**2)*XAP**4*0.5D0*0.21954D0
		 NFF = 32
	if(CONT) NFF=24
	call chops(NFF)
        WRITE(NFF,378) EC,BEL0,(SUMR(J),J=1,min(NOP,6))
C378     FORMAT(1X,F8.3,7E15.5)
 378     FORMAT(1X,F10.5,9F10.6)
C      BECON = RSUMMA +ASUMMA
C       BECONK = BECON*XAP**5
C        BECONE = BECON*XAP**4
C
C   *** NUCLEAR RESPONSE ENDED ****
C
C
C   *** EL - MAGN RO*COS(TETA)**2 M.E. ****
C
C ***  CALC OF <K L1 L2/RO**2*COS(TETA)**2/K1 L1 L2>    ****
C
            DO I = 1,MCHAN
      SUMI(I) = 0.D0
      SUMR(I) = 0.D0
      SUMI1(I) = 0.D0
      SUMR1(I) = 0.D0
            END DO
C
C  *** HYPERIMPULS LOOP
      DO 8780 IO = 1,NOP1
	     JFK=IOP(IO)
	if(KFAD(JFK).ne.1) go to 8780

      RSUMMA=0.D0
      ASUMMA=0.D0
      RSUMA =0.D0
      ASUMA =0.D0
C
      IJ = 1
      DO 8765 I = 1,NSTHE
      K  = KSTHE(I,1)/MULT(1)
      LL1= KSTHE(I,2)/MULT(2)
      JS1= KSTHE(I,3)/MULT(3)
      L1 = KSTHE(I,4)/MULT(4)
      L2 = KSTHE(I,5)/MULT(5)
       JBEG  = I
      DO 8765 J = JBEG,NSTGS
      K1 = KSTGS(J,1)/MULT(1)
      LL2= KSTGS(J,2)/MULT(2)
      JS2= KSTGS(J,3)/MULT(3)
      L12= KSTGS(J,4)/MULT(4)
      L22= KSTGS(J,5)/MULT(5)
      IF(LL1 .NE. LL2) GO TO 8765
      IF(JS1 .NE. JS2) GO TO 8765
      IF( L1 .NE. L12) GO TO 8765
      IF( L2 .NE. L22) GO TO 8765
      IF(KSTHE(I,7).ne.KSTGS(J,7)) GO TO 8765
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(
     x  	KSTGS(J,2)/MULT(2)+KSTGS(J,3)/MULT(3)- JTOTI +
     X		KSTHE(I,2)/MULT(2)+KSTHE(I,3)/MULT(3)-JTOT)
	endif
       IF(K .NE. K1) GO TO 8767
      IF( L1 .EQ.  L2) GO TO 8766
C
C  ****  LX .NE. LY CASE  ****
C
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+1.5D0)*(AN+L1+L2+2.D0)/(K+3)
      C2 =  AN*(AN+L1+.5D0)/(K+1)
      C1 =  (C1+C2)/(K + 2)
C
C  ***  RADIAL MATRIX ELEMENTS
C
      RSU = 0.D0
      ASU=0.D0
C
C
      DO  I1=1,IMAX
C
C
         R12 = rrade(I1)
	 H  = wrade(I1)
      IF(I1.GE.IMAGS)GO TO 310
          FULLL = FUL(J,I1)
            GO TO 311
 310      FULLL = FUL(J,IMAGS)*DEXP(XAPL*(RMGS-R12))
c311         R2 = (H*I1)**2
 311	     R2 = R12**2
      RSU       =REAL(FUH(IO,I,I1))*FULLL*R2*H +RSU
      ASU       =AIMAG(FUH(IO,I,I1))*FULLL*R2*H +ASU
          END DO
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C      WRITE(4,100) (KSTGS(J,M21),M21=1,7),(KSTHE(I,M1),M1=1,7)
C     *,RSU,ASU,c1
C 100  FORMAT(1X,' < 6GS ',7I3,' /RSU,ASU/ c1 ',7I3,' > =',3G12.4)
      RSU       = RSU      * C1
      ASU       = ASU      * C1
C
C  *** PARTIAL
      RSUMMA=RSUMMA+RSU
      ASUMMA=ASUMMA+ASU
         GO TO 8765
C
C   *** CASE KF=KI, LX=LY
C
 8766  C1 = 0.5D0
C
      RSU = 0.D0
      ASU=0.D0
C
      DO  I1=1,IMAX
        R2 = rrade(I1)**2
        H  = wrade(I1)
C
        IF(I1.GE.IMAGS) GO TO 331
                FULLL = FUL(J,I1)
            GO TO 332
 331             R12 = rrade(I1)
        FULLL = FUL(J,IMAGS)*DEXP(XAPL*(RMGS-R12))

 332     RSU       =REAL(FUH(IO,I,I1))*FULLL*R2*H +RSU
         ASU       =AIMAG(FUH(IO,I,I1))*FULLL*R2*H +ASU
          END DO
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C      WRITE(4,100) (KSTGS(J,M21),M21=1,7),(KSTHE(I,M1),M1=1,7)
C     *,RSU,ASU,c1
      RSU       = RSU      * C1
      ASU       = ASU      * C1
C
      RSUMMA=RSUMMA+RSU
      ASUMMA=ASUMMA+ASU
         GO TO 8765
C
C  *** CASE KI+2 = KF
C
 8767  CONTINUE
C  *** PARTIAL
      IF((K+2) .NE.K1) GO TO 8765
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K1+2)
      C1 =  AN*(AN+L1+.5D0)/ K1   * C1
      C1 =  DSQRT(C1)/(K1+1)
C
      RSU = 0.D0
      ASU=0.D0
C
      DO  I1=1,IMAX
C
         R2 = rrade(I1)**2
         H  = wrade(I1)
C
        IF(I1.GE.IMAGS) GO TO 361
                FULLL = FUL(J,I1)
            GO TO 362
 361             R12 = rrade(I1)
        FULLL = FUL(J,IMAGS)*DEXP(XAPL*(RMGS-R12))
 362     RSU       =REAL(FUH(IO,I,I1))*FULLL*R2*H +RSU
         ASU       =AIMAG(FUH(IO,I,I1))*FULLL*R2*H +ASU
          END DO
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C      WRITE(4,100) (KSTGS(J,M21),M21=1,7),(KSTHE(I,M1),M1=1,7)
C     *,RSU,ASU,c1
      RSU       = RSU      * C1
      ASU       = ASU      * C1
C
C  *** PARTIAL
      RSUMMA=RSUMMA+RSU
      ASUMMA=ASUMMA+ASU
 229   FORMAT('<',5I2,'/RO**2*COS(TETA)**2/',5I2,'> =',G12.4)
C        GO TO 8765
 8765 CONTINUE
C
        SUMR(IO) =  RSUMMA
        SUMI(IO) =  ASUMMA
C
      DO 9765 J = 1,NSTGS
      K1 = KSTGS(J,1)/MULT(1)
      LL2= KSTGS(J,2)/MULT(2)
      JS2= KSTGS(J,3)/MULT(3)
      L12= KSTGS(J,4)/MULT(4)
      L22= KSTGS(J,5)/MULT(5)
       IBEG  = J
      DO 9765 I = IBEG,NSTHE
      K  = KSTHE(I,1)/MULT(1)
      LL1= KSTHE(I,2)/MULT(2)
      JS1= KSTHE(I,3)/MULT(3)
      L1 = KSTHE(I,4)/MULT(4)
      L2 = KSTHE(I,5)/MULT(5)
      IF(LL1 .NE. LL2) GO TO 9765
      IF(JS1 .NE. JS2) GO TO 9765
      IF( L1 .NE. L12) GO TO 9765
      IF( L2 .NE. L22) GO TO 9765
      IF(KSTHE(I,7).ne.KSTGS(J,7)) GO TO 9765
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(
     x  	KSTGS(J,2)/MULT(2)+KSTGS(J,3)/MULT(3)- JTOTI +
     X		KSTHE(I,2)/MULT(2)+KSTHE(I,3)/MULT(3)-JTOT)
	endif
       IF(K .NE. K1) GO TO 9767
        GO TO 9765
C
C  *** CASE KI+2 = KF
C
 9767  CONTINUE
       IF((K1+2) .NE.K) GO TO 9765
      AN = (K-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K+2)
      C1 =  AN*(AN+L1+.5D0)/ K   * C1
      C1 =  DSQRT(C1)/(K+1)
C
      RSU = 0.D0
      ASU=0.D0
C
      DO  I1=1,IMAX
         R2 = rrade(I1)**2
         H  = wrade(I1)
C
        IF(I1.GE.IMAGS) GO TO 371
                FULLL = FUL(J,I1)
            GO TO 372
 371             R12 = rrade(I1)
        FULLL = FUL(J,IMAGS)*DEXP(XAPL*(RMGS-R12))
 372     RSU       =REAL(FUH(IO,I,I1))*FULLL*R2*H +RSU
         ASU       =AIMAG(FUH(IO,I,I1))*FULLL*R2*H +ASU
          END DO
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C      WRITE(4,100) (KSTGS(J,M21),M21=1,7),(KSTHE(I,M1),M1=1,7)
C     *,RSU,ASU,c1
      RSU       = RSU     * C1
      ASU       = ASU     * C1
C
C  *** PARTIAL
      RSUMA=RSUMA+RSU
      ASUMA=ASUMA+ASU
 9765      CONTINUE
        SUMR1(IO) =  RSUMA
        SUMI1(IO) =  ASUMA
CC
 8780      CONTINUE
CC  *** SUMMA OF PARTIAL M.E.
C
           ESUM = 0.D0
        DO I = 1,NOP1
           SUMI(I) = SUMI(I) + SUMI1(I)
           SUMR(I) = SUMR(I) + SUMR1(I)
           SUMR(I) =AL2*(SUMR(I)**2+SUMI(I)**2)
            if(CONT) SUMR(I) =SUMR(I)*DEN*WFN/XAP
            ESUM = ESUM + SUMR(I)
           END DO
C
      BEL  = ESUM
C
	call chops(NFI)
       WRITE(NFI,378) EC,BEL,(SUMR(J),J=1,min(NOP,6))

C
      RETURN
C
C   **** END OF B(E0) CALCUL   ********************************
C
C  ##########################################################################
C
C  ****  E1 TRANSITION
C
C *** ARRAY SI(R) CONTAINS THE PARTIAL MAT EL
 2000       DO I = 1,MCHAN
      SUMI(I) = 0.D0
      SUMR(I) = 0.D0
            END DO
	IOMIT = 0
	if(IOMIT>0) write(6,*) 'GS wf component ',IOMIT,' omitted!'
C
C ****** LOOP ON CONTNUUS SPECTRA (IMPULS)
C
       DO 2200  IO = 1,NOP1
	     JFK=IOP(IO)
	if(KFAD(JFK).ne.1) go to 2200
c     WRITE(4,101) (KSTHE(JFK,M1),M1=1,5) ,JFK
c101  FORMAT(1X,' < FINAL  ',5I3,' (',I3,') /START/  ')
C
C ****** LOOP ON CONTNUUS SPECTRA  (RADIUS)
      DO 2002  IF = 1,NSTHE
	if(KFAD(IF).ne.1) go to 2002
       KF = KSTHE(IF,1)/MULT(1)
        LF = KSTHE(IF,2)/MULT(2)
         ISF = KSTHE(IF,3)/MULT(3)
          LXF = KSTHE(IF,4)/MULT(4)
           LYF = KSTHE(IF,5)/MULT(5)
             JNF = KSTHE(IF,6)/MULT(6)
               ICF = KSTHE(IF,7)/MULT(7)
        if(prtran) write(4,94) 'IF,K,L,S,l1,l2,Jn,ii:',
     &              KF,LF,ISF,LXF,LYF,JNF,ICF
94      format(a20,8i3)

C ****** LOOP ON DISCRET SPECTRA
      DO 2003  II = 1,NSTGS
	SUMCHS(IF,II,IO) = 0.0
	if(KFADGS(II).ne.1.or.II==IOMIT) go to 2003
       KI = KSTGS(II,1)/MULT(1)
        LI = KSTGS(II,2)/MULT(2)
         ISI = KSTGS(II,3)/MULT(3)
          LXI = KSTGS(II,4)/MULT(4)
           LYI = KSTGS(II,5)/MULT(5)
             JNI = KSTGS(II,6)/MULT(6)
               ICI = KSTGS(II,7)/MULT(7)
          if(prtran) write(4,94) '-----initial>',
     &            II,KI,LI,ISI,LXI,LYI,JNI,ICI

C *****  GENERAL CHECK ON INACTIVE Q.N.
	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LI+ISI- JTOTI + LF+ISF-JTOT)
	endif
      IF(ICI .NE. ICF) GO TO 2003
        IF(ISF .NE. ISI) GO TO 2003
         IF(LXF .NE. LXI) GO TO 2003
          IF((KF+1) .LT. KI) GO TO 2003
C
      if(prtran)
     * WRITE(4,1011) (KSTGS(II,M21)/MULT(M21),M21=1,5),
     * 		     (KSTHE(IF,M1)/MULT(M1),M1=1,5)
1011  FORMAT(1X,' < GS ',5I3,' /START/  ',5I3,' > ')
C ********  LOOP ON LY+-1 **************************************
C
            DO 2004 NNL = 1,2
             IF(NNL .EQ. 1) IDLY = -1
             IF(NNL .EQ. 2) IDLY =  1
                  LYI1 = LYI + IDLY
C  *** SELECTION  ON LY
        IF(LYI1 .LT. 0) GO TO 2004
         IF(LYI1 .NE. LYF) GO TO 2004
C ********  LOOP ON KI+-1 **************************************
            DO 2005 NKI = 1,2
             IF(NKI .EQ. 1) IDKI = -1
             IF(NKI .EQ. 2) IDKI =  1
                  KI1 = KI + IDKI
C  *** SELECTION  ON K - 1
        IF(KI1 .LT. 0) GO TO 2005
         IF(KI1 .NE. KF) GO TO 2005
          IF(KI1 .LT. (LXI + LYI1)) GO TO 2005
C  *** SELECTION  ON L - 1, L, L + 1
C ********  LOOP ON L **************************************
C
                  DO 2020 JL = 1,3
        IDL = JL - 2
        LI1 = LI + IDL
            IF (LI1 .LT. 0) GO TO 2020
             IF (LI1 .NE. LF) GO TO 2020
C ***  2020 - END OF LOOP
C
      W = WRACA(1.D0,1.D0*LYI,1.D0*LI1,1.D0*LXI,1.D0*LYI1,1.D0*LI)
        WCF = (-1)**nint(1-JNI+ICF*0.5-JHE) 
     x     * sqrt((2.*JHE+1.)*(2.*JLI+1.)/(2*ICF*0.5+1))
     x     * WRACA(JLI,JHE,JNI+Z,JNF+Z,1d0,ICF*0.5d0)
        W = W * WCF
          IF(W .EQ. 0.D0) GO TO 2020

C   *** 2006 - CALC OF RADAL M.E.
        RSU = 0.D0
        ASU = 0.D0
C
	if(e1only) then
	  RSU = REAL(TRCHAN(IO,IF,II))
	  ASU = AIMAG(TRCHAN(IO,IF,II))
	else
	PR = II.le.3.and.IO+IF.le.3
	PR = II.le.1.and.IO+IF.le.2
	PR = PR .and. prtran
	if(PR) call chops(92)
	if(PR) write(92,380) II,IF,IO,EC
 380	format('# Gs,cont,out overlaps chs:',3I4,' @',F8.3,' MeV')
      DO  I=1,IMAX
C
         R1 = rrade(I)
         H  = wrade(I)
C
        IF(I.GE.IMAGS) GO TO 381
                FULLL = FUL(II,I)
            GO TO 382
 381             R12 = R1
        FULLL = FUL(II,IMAGS)*DEXP(XAPL*(RMGS-R12))
 382     continue
         RST       =REAL(FUH(IO,IF,I))*FULLL*R1
         AST       =AIMAG(FUH(IO,IF,I))*FULLL*R1
		if(mod(I,2).eq.0.and.PR)
c    x		write(92,383) R1,sqrt(RST**2 + AST**2)
     x          write(92,383) R1,RST,AST,FULLL,
     X                         REAL(FUH(IO,IF,I)),AIMAG(FUH(IO,IF,I))
 383		format(f8.3,5G13.5,f8.4)
         RSU       =RST*H +RSU
         ASU       =AST*H +ASU
        RSU1       =REAL(FUH(IO,IF,I))*FULLL*R1
        ASU1       =AIMAG(FUH(IO,IF,I))*FULLL*R1
      rsu2        =REAL(fuh(IO,if,i))
      asu2        =AIMAG(fuh(IO,if,i))
c      if(mod(i,10).eq.0) 
c    * write(1,384)R1,FULLL,rsu1,asu1,rsu2,asu2,rsu,asu
c    *,ksthe(if,1),kstGS(if,1)
c384   format(' @',f7.2,7g10.2,2i2)
            END DO
		if(PR) write(92,*) '&'
C
	endif
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C

      if(prtran) then
      WRITE(4,100) (KSTGS(II,M21)/MULT(M21),M21=1,5),
     *   	   (KSTHE(IF,M1)/MULT(M1),M1=1,5)
     *,RSU,ASU,W,PHASE
 100  FORMAT(' < GS ',5I2,' |E1|',5I2,'>=',3G12.4,I2)
      endif
C  ******  CHOICE OF K-DEPENDED COEFFICIENTS
C
        IF((IDLY .EQ. -1) .AND. (IDKI .EQ. -1)) GO TO 2021
                  GO TO 2122
 2021      ALP = -DSQRT(LYI*(KI-LXI+LYI+1.D0)*(KI+LXI+LYI+2.D0)/
     *             (KI+1.D0)/(KI+2.D0))
                  GO TO 2007
C
 2122     CONTINUE
        IF((IDLY .EQ. -1) .AND. (IDKI .EQ. 1)) GO TO 2022
                  GO TO 2123
 2022      ALP = -DSQRT(LYI*(KI-LXI-LYI+2.D0)*(KI+LXI-LYI+3.D0)/
     *             (KI+3.D0)/(KI+2.D0))
                  GO TO 2007
C
 2123     CONTINUE
        IF((IDLY .EQ.  1) .AND. (IDKI .EQ. -1)) GO TO 2023
                  GO TO 2124
 2023      ALP = DSQRT((LYI+1.D0)*(KI-LXI-LYI)*(KI+LXI-LYI+1.D0)/
     *             (KI+1.D0)/(KI+2.D0))
                  GO TO 2007
C
 2124     CONTINUE
        IF((IDLY .EQ. 1) .AND. (IDKI .EQ. 1)) GO TO 2024
                  GO TO 2020
 2024      ALP = DSQRT((LYI+1.D0)*(KI-LXI+LYI+3.D0)*(KI+LXI+LYI+4.D0)/
     *             (KI+3.D0)/(KI+2.D0))
C
 2007   CONTINUE
      if(prtran) then
      WRITE(4,1008) KF,LF,ISF,LXF,LYF,RSU,ASU,W,ALP,LI1,LYI1,KI,LI,ISI,
     x   		LXI,LYI
      endif
 1008  FORMAT(1X,' < F ',5I3,' /RSU,ASU,W,ALP,LI1,LYI1=',4G12.4,2I3,'/ '
     *,5I3,' I > ' )
C  *** PARTIAL
	 hch = ALP*0.5D0*DSQRT(2*LI1 + 1.D0)
	
        RSUP = RSU*0.5D0*DSQRT(2*LI1 + 1.D0)*ALP*W * sqrt(AL1)
         ASUP = ASU*0.5D0*DSQRT(2*LI1 + 1.D0)*ALP*W * sqrt(AL1)
          III = (-1)**(1+LI1+LI)
          SUMR(IO) = SUMR(IO) + RSUP*(-1)**(1+LI1+LI)
           SUMI(IO) = SUMI(IO) + ASUP*(-1)**(1+LI1+LI)
	    R1 = 3.0
            if(CONT) R1 = R1 *DEN*WFN/XAP
	    R1 = sqrt(R1) 
	SUMCHS(IF,II,IO) = SUMCHS(IF,II,IO) + DCMPLX(RSUP,ASUP)*R1
C
c      if(jfk.le.2) write(2,33) EC,JFK,IF,II,
c    X       sqrt(AL1*W),rsu,asu,hch,iii,rsup,asup,sumr(jfk),sumi(jfk)
c33    format('BE:',f6.3,i3,2i2,';',4f8.4,I3,4f8.4)
 2020     CONTINUE
C             END DO
 2005     CONTINUE
 2004     CONTINUE
 2003     CONTINUE
 2002     CONTINUE
 2200     CONTINUE
CC
C   **** SUM OF B(E1) CALCUL   ********************************
C
	    R1 = 3.0
            if(CONT) R1 = R1 *DEN*WFN/XAP
	    R1 = sqrt(R1) 

            ESUM = 0.D0
        DO I = 1,NOP1
	  sumr1(I) = sumr(I) * R1
	  sumi1(I) = sumi(I) * R1
	 if(KFAD(IOP(I)).eq.1) then
	  
          W = 3d0*(SUMR(I)**2+SUMI(I)**2)
            if(CONT) W = W *DEN*WFN/XAP
          ESUM = ESUM + W
	  sumr(I) = W
	endif
        END DO
C
      BEL  = ESUM
C
C ***** FOR PRINT
C
	call chops(NFI)
	call chops(100+NFI)
      WRITE(NFI,378) EC,BEL,(SUMR(J),J=1,min(NOP,6))
      WRITE(100+NFI,*) EC,(cmplx(sumr1(J),sumi1(J)),J=1,NOP1)
c     WRITE(NFI,378) EC,BEL
      if(prtran) then
        WRITE(4,378) EC,BEL,(SUMR(J),J=1,min(NOP,6))
	endif
      write(16,3377) EC,((abs(SUMCHS(IF,II,1)),IF=1,4),II=1,4)
3377     FORMAT(f8.3,16f8.5)
      call flush(16)
C   **** END OF B(E1) CALCUL   ********************************
C
           GO TO 5000
C-------------------------------------------------------------------------
C
C  *****   E2 CALCUL  ********
C
 3000   CONTINUE
	ASUM =  A1 + A3 +A2
        AJ = (2.D0*JHE+1)/(2.D0*JLI + 1)
         ALF = (A1 + A2)/ASUM/A3

           J  = IE
	   L  = IE
	   ISIG=0
      	if(prtran) WRITE(4,3001) JLI,L,ISIG,J,JHE
3001  FORMAT(1X,'<',f4.1,'|  LSJ   =',3I3,' |',f4.1,'>')
        ZZ  = Z3**2*AJ
        ESUM = 0.D0
C
C ****** LOOP ON CONTNUUS SPECTRA (IMPULS)
C
       DO 3200  IO = 1,NOP1
	JFK = IOP(IO)

c	write(4,*) 'Incoming ',IO,' in ch.',JFK
	SUMR1(IO)= 0.D0
	SUMI1(IO)= 0.D0
	if(KFAD(JFK).ne.1) go to 3200
C
C  **** LOOP ON LI=INIT QUANT. NUMBERS ****
C
C
         DO 3101 NSL = 1,NSTGS
C
      KLI = KSTGS(  NSL,1)/MULT(1)
       LLI = KSTGS(  NSL,2)/MULT(2)
        ISLI = KSTGS(  NSL,3)/MULT(3)
         L1LI = KSTGS(  NSL,4)/MULT(4)
           L2LI = KSTGS(  NSL,5)/MULT(5)
             JNLI = KSTGS(  NSL,6)/MULT(6)
               ICLI = KSTGS(  NSL,7)/MULT(7)
        if(prtran) write(4,94) 'K,L,S,l1,l2,Jn,ii:',
     &              KLI,LLI,ISLI,L1LI,L2LI,JNLI,ICLI
C
C  **** LOOP ON HE=FIN QUANT. NUMBERS ****
C
         DO 3101 NSH = 1,NSTHE
	  if(KFADGS(NSL).ne.1) go to 3101
	  if(KFAD(NSH).ne.1) go to 3101
C
      KHE = KSTHE(  NSH,1)/MULT(1)
       LHE = KSTHE(  NSH,2)/MULT(2)
        ISHE = KSTHE(  NSH,3)/MULT(3)
         L1HE = KSTHE(  NSH,4)/MULT(4)
           L2HE = KSTHE(  NSH,5)/MULT(5)
             JNHE = KSTHE(  NSH,6)/MULT(6)
               ICHE = KSTHE(  NSH,7)/MULT(7)
          if(prtran) write(4,94) '-----final>',
     &            KHE,LHE,ISHE,L1HE,L2HE,JNHE,ICHE

	if(slorder==1) then
	PHASE = 1d0
	 else
	PHASE = (-1)**nint(LLI+ISLI- JTOTI + LHE+ISHE-JTOT)
	endif
C
C ****  QUADRUPOLE SELECTION RULES  *************
C
      IF(ICLI.NE. ICHE) GO TO 600
      IF(ISLI.NE. ISHE) GO TO 600
      IF(IABS(KLI - KHE).GT.2) GO TO 600
      IF(IABS(L2LI - L2HE).GT.2) GO TO 600
        IF(L1HE  .NE. L1LI )GO TO 600
C  *****

c      WRITE(4,4646) L1HE ,L2HE ,LHE,ISHE,JHE,KHE
c4646  FORMAT(1X,'<  L1HE1,L2HE ,LHE,ISHE,JHE,KHE =',6I3,' /')
c      WRITE(4,4648) L,ISIG,J  
4648  FORMAT(1X,'/  L  ,ISIG,J   =',3I3,' /')
c      WRITE(4,4647) L1LI ,L2LI ,LLI,ISLI,JLI,KLI
c4647  FORMAT(1X,'/  L1LI1,L2LI2,LLI,ISLI,JLI,KLI =',6I3,' >')

      CALL ANGSPI(S1,S2,L1HE ,L2HE ,LHE,ISHE,JHE,L ,ISIG,J,
     *                  L1LI ,L2LI ,LLI,ISLI,JLI,AS)
c       WCF = (-1)**(JNLI+JNHE+JHE+2) *
c    x       sqrt((2.*JHE+1.)*(2.*JLI+1.)) *
c    x       WIG6J(JLI,JHE,2d0,JNHE+Z,JNLI+Z,ICHE*0.5d0)
        WCF = (-1)**nint(2-JNLI+ICHE*0.5-JHE) 
     x     * sqrt((2.*JHE+1.)*(2.*JLI+1.)/(2*ICHE*0.5+1))
     x     * WRACA(JLI,JHE,JNLI+Z,JNHE+Z,2d0,ICHE*0.5d0)
	ANGS = AS
        AS = AS * WCF

      CALL HANGMEQ(KHE,L1HE,L2HE,KLI,L1LI,L2LI,HANG)

C       WRITE(4,4649) JFK,NSH,NSL,AS,HANG
4649  FORMAT(1X,3I3,': AS,HANG=',2G12.3)

c      IF(DABS(AS) .LT. 1.D-10) GO TO 600
C
        RSU = 0.D0
        ASU = 0.D0
C
	if(e1only) then
	  RSU = REAL(TRCHAN(IO,NSH,NSL))
	  ASU = AIMAG(TRCHAN(IO,NSH,NSL))
	else
      DO  I=1,IMAX
         R1 = rrade(I)
         H  = wrade(I)
         RO2= R1**2
        IF(I.GE.IMAGS) GO TO 581
                FULLL = FUL(NSL,I)
            GO TO 582
 581             R12 = R1
        FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(RMGS-R12))
 582     RSU       =REAL(FUH(IO,NSH,I))*FULLL*RO2*H +RSU
         ASU       =AIMAG(FUH(IO,NSH,I))*FULLL*RO2*H +ASU
      END DO
	endif
	RSU = RSU*PHASE
	ASU = ASU*PHASE
C      RSU       =RSU * H * ALF * AS * HANG
       SUMR1(IO) = SUMR1(IO) + RSU * ALF * AS * HANG
       SUMI1(IO) = SUMI1(IO) + ASU * ALF * AS * HANG
        if(prtran) write(4,590) ' recoil',
     x            ANGS,WCF,HANG,RSU,AS*HANG*RSU,SUMR1(IO)/ALF
590     format(a20,6g10.3)

C       WRITE(4,5515) IO,NSH,NSL,RSU,ASU,SUMR1(IO),SUMI1(IO)
 5515 FORMAT(3X,3I3,' E2,sum E2 =',4G12.4)
 9515 FORMAT(' *** CLUSTER  A=',F3.0,'  Z=',F3.0,I3,' BE2 =',2G12.4/)

c     WRITE(4,3120)KHE,LHE,L1HE ,L2HE ,RSU,ASU,KLI,LLI,L1LI,L2LI
c3120  FORMAT(' <ex:K,LL,L1,L2=',4I2,'/M=',2G11.3,'/gs: ',4I2,'>')
c      WRITE(4,3120)NSH,KHE,LHE,L1HE,L2HE ,RSU,ASU,AS,HANG,
c     x		KLI,LLI,L1LI,L2LI,SUMR1(IO),SUMI1(IO)
c3120  FORMAT(' <ex:#,K,LL,L1,L2=',i3,4I2,'/M=',2G11.3,2f8.3,
c     x		'/gs: ',4I2,'> =',2g11.3)

600	continue
C				CORE E2 contribution using Q0CORE and KTARG
c				QN must agree for all neutrons, not core:
	do 602 i=1,6
602	if(KSTGS(NSL,i).ne.KSTHE(NSH,i)) go to 3101
	if((ICLI+ICHE)/2.lt.2 .or. abs(ICLI-ICHE)/2.gt.2) go to 3101
	CORE = Q0CORE * sqrt(ICLI+1.) 
     x		* cleb6(ICLI*0.5d0,KTARG,2d0,0d0,ICHE*.5d0,KTARG)
	AS = (-1)**nint(JNHE+2-JLI-ICHE*.5) * sqrt((2.*JLI+1.)) 
     x	  *  WRACA(JLI,JHE,ICLI*.5d0,ICHE*.5d0,2d0,JNHE+Z)
	E2core = AS*CORE

        RSU = 0.D0
        ASU = 0.D0
C
	if(e1only) then
	  write(6,*) ' Need wfns for E2 core contributions!!'
	else if(abs(E2core).ge.1d-6) then
      DO  I=1,IMAX
	IGS = I*iwfskp	
         H  = wrad(IGS) * iwfskp
        IF(IGS.LT.IMAGS) THEN
           FULLL = FUL(NSL,IGS)
         ELSE
           R1 = rrad(IGS)
           FULLL = FUL(NSL,IMAGS)*DEXP(XAPL*(RMGS-R1))
  	 ENDIF
         RSU       =REAL(FUH(IO,NSH,I))*FULLL*H +RSU
         ASU       =AIMAG(FUH(IO,NSH,I))*FULLL*H +ASU
        END DO
	endif
	RSU = RSU*PHASE
	ASU = ASU*PHASE

       SUMR1(IO) = SUMR1(IO) + RSU * E2core 
       SUMI1(IO) = SUMI1(IO) + ASU * E2core
	if(prtran) write(4,590) ' core  ',
     x			AS,CORE,RSU,E2core*RSU

3101  CONTINUE

C       WRITE(4,9515) A3,Z3,IO,SUMR1(IO),SUMI1(IO)

CC
C   **** SUM OF B(E2) CALCUL   ********************************
C
          SUMR(IO) =ZZ*(SUMR1(IO)**2+SUMI1(IO)**2)
            if(CONT)  SUMR(IO) =  SUMR(IO) *DEN*WFN/XAP
          ESUM = ESUM + SUMR(IO)
3200 	CONTINUE 
C
      BEL  = ESUM
C
C ***** FOR PRINT
C
	call chops(NFI)
        WRITE(NFI,3378) EC,BEL,(SUMR(J),J=1,min(NOP,6))
	call chops(100+NFI)
	    R1 = ZZ
            if(CONT) R1 = R1 *DEN*WFN/XAP
	    R1 = sqrt(R1) 
        WRITE(100+NFI,*) EC,(R1*cmplx(sumr1(J),sumi1(J)),J=1,NOP1)
 3378     FORMAT(1X,F10.5,7G13.4)
C   **** END OF B(E2) CALCUL   ********************************

C
 4000   CONTINUE
 5000   RETURN
        END
C
      SUBROUTINE ANGSPI(S1,S2,L1H,L2H,LHE,ISHE,JHE,L ,ISIG,J,
     *                  L1L,L2L,LLI,ISLI,JLI,AS)
        IMPLICIT REAL*8(A-H,O-Z)
	real*8 JHE,JLI
C *********************************************************************
C       SPIN - ANGULAR MATRIX ELEMENT FOR DENSITY OPERATOR            *
C               < L,M, SIG,M(SIG)/J,M(J)>                             *
C             IT ACTS ON A SUBSYSTEM 2    (L1H = L1L)                 *
C          CASE OF NUCLON  S1 = S2 = 1/2      *
C *********************************************************************
C                                                                     *
            PI = 3.14159D0
 100     RMES =  DSQRT(6.D0)
        IF(ISIG .EQ. 0) RMES = DSQRT( 2.D0*S1 + 1.D0)
         RMEL =  DSQRT(  2* L2H+1.D0)
         RMEL =  DSQRT(  2* L2L+1.D0)*RMEL
         RMEL =  DSQRT(  2* L  +1.D0)*RMEL
C         WRITE(*,*)' ANGSPI '
C         WRITE(*,*)' ANG 1',L2H,L,L2L,'LH,L,LL'
C         WRITE(4,*)' ANG 1',L2H,L,L2L,'LH,L,LL'
       IF((L+L2L).LT.L2H.OR.(L+L2H).LT.L2L.OR.(L2H+L2L).LT.L)GO TO 1000
         WIG1 =                 WIG(2*L2H,2*L,2*L2L,0,0)
C         WRITE(4,*)' ANG 2'

          IF(WIG1 .EQ. 0.D0) GO TO 1000
C            WRITE(*,8)L2H,L,L2L,WIG1
    8    FORMAT('WIG: L2H,L,L2L=',3I3,G12.3/)
         RMEL =  (-1)**L2H*RMEL*WIG1/DSQRT(4.D0*PI)
 1002     CONTINUE
C
C   ****  NUCLEON CASE : S1 = S2 = 1/2     S1+S2 = 1
C
  311     IF(ISLI.NE. ISHE) GO TO 1000
         A = (-1)**(L1H - L2H + LHE +L + nint(JHE-JLI))*RMES*RMEL
         A = DSQRT( 2.D0*LHE  + 1.D0) * A
         A = DSQRT( 2.D0*LLI  + 1.D0) * A
         A = DSQRT( 2.D0*JLI  + 1.D0) * A
         A = A/DSQRT( 2.D0)
C         WRITE(4,*)' ANG 3',A
	 A0 = A

        A =
     *  WRACA(1.D0*L2H,1.D0*LHE,1.D0*L2L,1.D0*LLI,1.D0*L1L,1.D0*L)* A
C         WRITE(4,*)' ANG 4',A

        AS=
     *  WRACA(1.D0*ISHE,1.D0*LLI,JHE,1.D0*L,JLI,1.D0*LHE)* A
C         WRITE(*,*)' ANG 5'
c        WRITE(4,10) WIG1,RMEL,A0,A,AS
10	format(' ANG 5',5g11.3)

             RETURN
C ***
 1000   AS= 0.D0
c       WRITE(4,*)' !!!!!!!  ANGSPI: SLECTION RULES !!!!!!!'
c       WRITE(4,*) ' WIG1,ISLI,ISHE=',WIG1,ISLI,ISHE
                END
C
C ************************************************************************
C
        SUBROUTINE HANGMEQ(K,L1,L2I,K1,L12,L22,HANG)
C
        IMPLICIT REAL*8(A-H,O-Z)
C######################################################################
C     Calcul. of hyperangle Mat. El-s for <f/cos(alpha)**2/i>
C             f = He, i = Li
C    *******************************************************************
C
C   *** EL - MAGN RO*COS(TETA)**2 M.E. ****
C
C ***  CALC OF <K L1 L2/RO**2*COS(TETA)**2/K1 L12 L22>    ****
C
	L2 = L2I
C      K  = KSTHE(I,1)
C      LL1= KSTHE(I,2)
C      L1 = KSTHE(I,4)
C      L2 = KSTHE(I,5)
C      K1 = KSTGS(J,1)
C      LL2= KSTGS(J,2)
C      L12= KSTGS(J,4)
C      L22= KSTGS(J,5)
      IF( L1 .NE. L12) GO TO 8765
      IF( L2 .NE. L22) GO TO 9765
       IF(K .NE. K1) GO TO 8767
      IF( L1 .EQ.  L2) GO TO 8766
C
C  ****  LX .NE. LY CASE  ****
C
      AN = (K1-L1-L2)/2.D0
      C1 = (AN+L2+1.5D0)*(AN+L1+L2+2.D0)/(K+3)
      C2 =  AN*(AN+L1+.5D0)/(K+1)
      C1 =  (C1+C2)/(K + 2)
C
	HANG = C1

	RETURN
C
C __________________________________________________________
C   *** CASE KF=KI, LX=LY
C
 8766  C1 = 0.5D0
C
	HANG = C1

	RETURN
C
C
C _________________________________________________________
C  *** CASE ABS(KI - KF) = 2
C
 8767  CONTINUE
C  ***
      IF(IABS(K - K1) .NE. 2) GO TO 8765
	K11 = MAX0(K,K1)
      AN = (K11-L1-L2)/2.D0
      C1 = (AN+L2+0.5D0)*(AN+L1+L2+1.D0)/(K11+2)
      C1 =  AN*(AN+L1+.5D0)/ K11   * C1
      C1 =  DSQRT(C1)/(K11+1)
C
	HANG = C1

	RETURN
C
C _________________________________________________________
C  ****  LYI .NE. LYF CASE  ****
C
 9765 CONTINUE
C
	IF(L2 - L22) 1,8765,2

 2	L2 = L22
         KK = K
          KK1 = K1

	GO TO 10

 1	KK = K1
         KK1 = K

 10     IF (KK1 - KK) 4,5,6

C *****  K1 = K - 2
 4       AN = (KK1-L1-L2)/2.D0
C        WRITE(*,*)'m4 ',KK1,L1,L2
           C1 = (AN+L2+1.5D0)*(AN+L2+2.5D0)*(KK1+2)
      C1 = C1/((AN+L1+L2+3.D0)*(AN+L1+L2+2.D0)*(KK1+4))
	C1 = DSQRT(C1)
      C2 = (AN+L1+L2+2.D0)*(AN+L1+L2+3.D0)/((KK1+2.D0)*(KK1+3.D0))

      C1 =  C1*C2
C
	HANG = C1

	RETURN
C
C

C *****  K1 = K
 5       AN = (KK1-L1-L2)/2.D0
C         WRITE(*,*)'m5 ',KK1,L1,L2

      C1 = (AN+L2+1.5D0)*AN
      C1 = C1/((AN+L1+0.5D0)*(AN+L1+L2+2.D0))
	C1 = DSQRT(C1)
      C2 = 2.D0*(AN+L1+L2+2.D0)*(AN+L1+0.5D0)/((KK1+1.D0)*(KK1+3.D0))

      C1 =  C1*C2

C
	HANG = C1

	RETURN
C
C *****  K1 = K + 2
 6       AN = (KK1-L1-L2)/2.D0
C        WRITE(*,*)'m6 ',KK1,L1,L2,AN
        IF(DABS(AN-1.D0).LE. 1.D-10) GO TO 8765

      C1 = AN*DABS(AN - 1.D0)*(KK1+2)
C        WRITE(*,*)'C1',C1
      C1 = C1/((AN+L1+0.5D0)*(AN+L1-0.5D0)*KK1)
C        WRITE(*,*)'C1',C1
        C1 = DSQRT(C1)
      C2 = (AN+L1+0.5D0)*(AN+L1-0.5D0)/((KK1+2.D0)*(KK1+1.D0))

      C1 =  C1*C2
C
	HANG = C1

C        WRITE(*,*)'M6',HANG
	RETURN
C
C
 8765 CONTINUE
C
	HANG = 0.D0
        WRITE(*,*)'HANGMEQ: SELECTION RULES HANG=',HANG

C
C   **** END OF HYPERANGLE MAT. EL. CALCUL   ********************************
       RETURN
	END
