	Subroutine InputSturm
	use parameters
      	use globals
      	use pauli
      	use gs
      	use scattering
      	use xlrm
        implicit real*8 (a-h,o-z)
	character*5 what(0:nkind-1),body*8,solns*20,kindeig(2),
     x		whatd(0:3)
	character*10 pwfs(0:4)
	character lin
	data pwfs/'None','GS only','Diag. scat','All scat','All asymp'/
	data kindeig/'first','later' /
	data what/'Coul ','WS  ','Diag','Const','Readf','1/r^3' ,
     x	          'Eigen','Cl/Dg','    ','     ' /
	data whatd/'Coul ','WS  ','Gauss','1/r^3' /
c
C				Combined sturmin and xlrin namelists:

      namelist /sturmin/ 
     x	 Eo,sturm,egsmin,egsmax,ngsmax,maxset,ipflg,numax,rmaxsc,meigs,
     x	 stepi,rmax,lprwf,wfrmax,turnmax,minnop,prrexp,steps,nlam,
     x	 nsturm,buttle,prbut,pralpha,prsturm,prmats,rafin,pertcent,
     X   pripot,maxnop,rtrans,htrans,xlrgs,potcoef,tinside,elinear,
     X   ktransmax,ltransmax,vdiag,rdiag,adiag,kdiag,nidiag,discrete,
     x	 Vsturm,rsturm,asturm,A,kind,    prtran,fadex,nogscat,strfun,
     x 	 ebeg,estep,emax,prrm,prkm,prtm,e1only,wfs,prns,mlpr,rinte,
     X	 gfact,rfact,rafix,maxtry,mblock,efermi,eeigmax,simeq,cutl,cutr,
     x            nftt,prwf,prwr,prbc,debug,
     X            ncol,abvthr,belthr,ewron,apeps,
     X            degeny,iasy,apflg,msurf, 
     X            idiscr,betalw,cuplim,deplim,prntv,
     X		  prntr,flwp,flwpr
	ion = 0
*
      call indefaults (Eo,sturm,egsmin,egsmax,ngsmax,maxset,ipflg,
     x	 stepi,rmax,lprwf,wfrmax,turnmax,minnop,rafin,numax,nlam,
     x	 nsturm,buttle,prbut,pralpha,prsturm,prmats,pertcent,prrexp,
     x	 Vsturm,rsturm,asturm,A,kind,    prtran,steps,rmaxsc,fadex,
     x 	 ebeg,estep,emax,prrm,prkm,prtm,e1only,wfs,prns,mlpr,rinte,
     x   nogscat,maxtry,rfact,rafix,gfact,apflg,mblock,eeigmax,strfun,
     x   rtrans,htrans,maxnop,xlrgs,meigs,pripot,tinside,simeq,
     X   elinear,ltransmax,ktransmax,cutl,cutr,vdiag,rdiag,adiag,
     X   kdiag,nidiag,discrete)
	 rmax = rinner
      call nldft (nftt,prwf,prwr,prbc,debug,
     X                  ipflg,ncol,abvthr,belthr,ewron,apeps,
     X			degeny,iasy,apflg,ion,msurf,
     X                  idiscr,betalw,cuplim,deplim,prntv,
     X                  prntr,flwp,flwpr)
*
      read (IIN,sturmin,IOSTAT=ios,end=2,err=2)
   2  if ( ios .ne. 0 ) then
         write (iout,*) ' Input namelist read errror: ',IOS
         write (iout,sturmin)
         stop
      endif
      if (ipflg .ge. 2) write (iout,sturmin)
c
	do ist=1,2
	if(sturm(ist).eq.'t') sturm(ist)='T'
	if(sturm(ist).eq.'f') sturm(ist)='F'
	if(sturm(ist).eq.'l') sturm(ist)='L'
	enddo
	if(sturm(1).eq.'L') sturm(2)='L'

c					Radial ranges of different kinds:
        iwfskp = max(nint(steps/stepi),1)
	glag = sturm(1).eq.'L'
        if(glag) iwfskp=1
c					numr even for Simpson's rule
c					So numrs1 must be even
c					 to allow for any iwfskp
	steps = stepi*iwfskp
	numrs1 = nint(Rmax/steps)
	numrs1 = max(numrs1,1)
	if(nsturm.gt.0) then
	  numrs1 = max(numrs1,2)
	  numrs1 = (numrs1/2)*2
	  endif
	numr   = numrs1* iwfskp
	Rmax=numr*stepi
	  if(wfrmax.le.0.1) wfrmax = Rmax
	numrs = nint(wfrmax/steps)
	wfrmax = numrs * steps
	  if(abs(turnmax).le.0.1) turnmax = max(wfrmax,Rmax)*2.0
	asymp = rafin .gt. Rmax
	if(asymp) rafin = max(rafin,wfrmax)
	if(rmaxsc.le.0.1) rmaxsc = Rmax
	rmaxsc = min(rmaxsc,Rmax)
	numrs2 = nint(rmaxsc/steps)
	numrs2 = (numrs2/2)*2
	numr2  = numrs2* iwfskp
	rmaxsc = numr2 * stepi
	rmaxi = rmax
	rafini= rafin
	nsturmi=nsturm

	print*
	body = '  two   '
	if(nbody.eq.3) body = 'three   '
	if(nbody.gt.3) body = ' many   '
	solns = 'solutions -'
	if(fad) solns = 'Faddeev solutions -'
!	print*,' - Sturmians for ',body(1:5),'-body ',solns
	print*,' - Sturmians for ',nbody,'-body ',solns
	print*
	do 1001 ist=1,2
	if(sturm(ist).eq.'T') write(IOUT,9)  kindeig(ist),Eo(ist)
9	format('  For ',A5,' J,pi : Eo =',F8.3,'  with Sturmians')
	if(sturm(ist).eq.'L') write(IOUT,901)  kindeig(ist),Eo(ist)
901     format('  For ',A5,' J,pi : Eo =',F8.3,'  with Laguerre Basis')
	if(sturm(ist).eq.'F') write(IOUT,10)  kindeig(ist),Eo(ist)
10      format('  For ',A5,' J,pi : Eo =',F8.3,'  with Energy ',
     &						       ' Eigenstates')
1001    continue
	if(npots>1.or.abs(potcoef(1)-1d0)>1e-9) 
     &		write(IOUT,1002) potcoef(1:npots)
1002	format(/'  Use Potential Coefficients of ',/(9x,5f10.5))
	if(abs(vdiag(1))+abs(vdiag(2))>1e-10) write(IOUT,1003) 
     & 		kdiag,whatd(mod(kdiag,4)),vdiag,rdiag,adiag,nidiag
1003	format(/'  Add DIAGONAL potential ',i1,'=',a5,/'       with ',
     &   'parameters V1,V2,R1,R2,A =',5f10.5,i3)
      	write(IOUT,101) egsmin,egsmax,ngsmax,maxset
101	format(/'  Look from ',F8.3,' to ',F8.3,' MeV for',I4,
     &          ' eigenstates in ',I3,' J/parity sets')

	write(IOUT,11) stepi,Rmax,numr,wfrmax,steps
11	format(/'  Stepi =',F6.3,'  Rmax =',F5.1,'  numr =',I5,
     &	', wave functions to ',f7.1,' fm in steps of',f5.2)

	allocate (rrad(numr),wrad(numr),rrade(numrs),wrade(numrs))
	step = stepi
        if(.not.glag) then
c				rrad/wrad is for integration [0,rmax]
	  g=4.d0/3.d0
	  do  i=1,numr
	    if(i.eq.numr) g = 1d0/3d0
	    rrad(i) = i*step
	    wrad(i) = step*g
	    g=2d0-g
	   enddo
c				rrade/wrade is for integration [0,wfrmax]
	  g=4.d0/3.d0
	  do  i=1,numrs
	    if(i.eq.numrs) g = 1d0/3d0
	    rrade(i) = i*steps
	    wrade(i) = steps*g
	    g=2d0-g
	   enddo
	else
c				Laguerre basis: no extensions!
	  numr = max(numr/20,nsturm)
	  call factorial
	  call qualag(rrad,wrad,numr,alf)
c	  step = stepi*10
	  step = Rmax/rrad(numr)
	  steps = step
	  numrs = numr
	  write(IOUT,1104) numr,step,alf
1104     format(/' Using ',I4,' Gauss-Laguerre points with scale',
     & 		 F8.3,' fm., and alf =',f8.4)
	  do 1106 i=1,numr
	    U = rrad(i)
   	    wrad(i) = wrad(i) / (U**alf * exp(-U))
            rrad(i) = rrad(i) *step
	    rrade(i) = rrad(i)
1106	    wrade(i) = wrad(i)
          write(IOUT,1108) (rrad(j),j=1,numr)
1108     format(' Radii:   ',8f8.3,:,/(10x,8f8.3))
	endif
	
	if(nsturm.eq.0) buttle=0
	if(nsturm.eq.1) nsturm = 1.0 * max(nint(rinner),15)
	write(IOUT,12) nsturm,buttle,prbut,pralpha,prsturm,prmats,pripot,
     &     		cutl,stepi,cutr
12	format(/'   nsturm =',I3,',  Buttle =',I2,/,
     &   '   Printing: buttle=',L1,', alpha=',L1,', basis wf=',L1,
     & 	 ', matrices=',L1,', potentials=',L1,/,
     &   '   Count basis nodes outside max(',f5.1,'*',f8.3,',',f5.1,')')
	if(sturm(2).ne.'F'.and.buttle.ne.0) then
	    write(IOUT,*) ' Buttle corrections only implemented for',
     &          ' energy eigenstates basis '
		buttle = 0
		endif
	if(pertcent) write(IOUT,902) 
902	format(/'   Moving centrifugal barrier from basis to ',
     & 			'perturbation')
	if(eeigmax.gt.0.) write(IOUT,903) eeigmax
903	format(/'   Include interior eigenstates only to',f12.4,' MeV')

	RRsturm=rsturm*A**(1.d0/3.d0)
	kindi=kind
	if(sturm(1).eq.'T'.or.sturm(2).eq.'T') then
	 if(kindi==9) kind=0
       	 if(kind/=2) write(IOUT,16) kind,what(mod(kind,nkind)),
     &                 Vsturm,Rsturm,asturm,A,RRsturm
       	 if(kind==2) write(IOUT,16) kind,what(mod(kind,nkind))
16	format(/'  Sturmian potential will use kind ',I2,'=',A5,':'
     &   ,:,   /'  Vsturm =', F6.2,' rsturm =',F6.3,' asturm =',F5.2,
     &          ' A = ',F6.1,' => RRsturm =',F8.3)
	endif
	if(sturm(2).eq.'F'.or.sturm(2).eq.'F') then
	 if(kindi==9) kind=2
       	 if(kind/=2) write(IOUT,17) kind,what(mod(kind,nkind)),
     &                 Vsturm,Rsturm,asturm,A,RRsturm
       	 if(kind==2) write(IOUT,17) kind,what(mod(kind,nkind))
17	format(/'  Energy eigenstates will use potential kind ',I2,'=',
     &   A5,:, /'  Vsturm =', F6.2,' rsturm =',F6.3,' asturm =',F5.2,
     &          ' A = ',F6.1,' => RRsturm =',F8.3)
	endif

	if(e1only) wfs = .false.
	if(strfun) wfs = .true.
	doscat = emax.gt.ebeg .or. discrete
	doscat = .true.
	lin = 'k'
	if(elinear) lin = 'E'
	write (IOUT,19) ebeg,lin,estep,emax
19	format(/2X,'SCATTERING Calculation:',/,
     &  '   Incident energy: E from',
     *       F6.2,' in ',a1,'-linear steps of',F7.3,' to',F7.2,' MeV')
	if(estep<0.0.or.nogscat) write(IOUT,1905) 
1905	format('   Since estep < 0 or nogscat=T, no scattering ',
     X		'for first J/pi set')
	if(doscat) then
	write (IOUT,191) e1only,wfs,strfun,discrete,prrm,prkm,prtm
191     format('   Continuum: E1 only =',L2,', wfs =',L2,
     &         ', strength fns =',L2,', discrete responses =',L2,/,
     %  '              Print Rmat =',L2,', Kmat =',L2,', Tmat =',L2/)
	mtrans = nint(rtrans/htrans)
	if(mtrans.gt.1) write (IOUT,199) mtrans,rtrans,ktransmax,
     X			ltransmax
199     format('   Calculate transition densities in',i3,' steps to',
     $         f8.2,' fm. with values of K <=',I3,' and L <=',I3/)
	if(rmaxsc.lt.Rmax) write(IOUT,20) rmaxsc
20	format('   Rmax reduced to ',F7.3,' for scattering.'/)
	if(turnmax.ne.0.0.or.maxnop.ne.0) 
     &   write(IOUT,21) turnmax,minnop,maxnop,ktransmax
21	format('   Omit incoming partial waves with turning point >',
     &	    f8.2,' fm.,',/
     &  '      but at least',i3,' channels kept,',i3,' maximum,',
     & 	 ' ktransmax =',i2)
	MNOP = maxnop
	if(wfs) write(IOUT,23) steps,wfrmax,iwfskp
23	format('   Find scattering wave functions every ',f6.3, ' to',
     &		F7.2,' fm (from iwfskp =',i3,')')
	if(asymp) write(IOUT,22) rafin,numax
22	format('   Propagate (LW) wave functions to ',f10.3,' fm',/,
     &	       '   then with r^-numax =',i2,' Gailitis couplings'/)
	if(tinside>0) write(IOUT,231) tinside
231	format('   Start integrations at',f8.1,' inside a classical',
     &	 ' turning point'/)
	endif
	if(.not.asymp) 
     & 	  write(IOUT,*) '   NO asymptotic coupled wave functions'
c	write(IOUT,*) ' So ',numrs,' - ',numrs1,'=',numrs-numrs1,
c    &		' are found by xlr'
	write(IOUT,24) lprwf,pwfs(lprwf)
24	format(/'   File wave functions:',I2,' =',A10/)
	simeq = simeq.and..not.(wfs.or.e1only.or.mtrans>1)
	if(simeq) write(IOUT,904) 
904	format(/'   Linear equations for only one scattering R-matrix')
	if(simeq) MEIGS=1

	numrmax = numr+1
	nmax = nsturm
	nmaxf = numrs
	nmaxb=nmax*6

 	return
	end
      subroutine indefaults (Eo,sturm,egsmin,egsmax,ngsmax,maxset,ipflg,
     x	 stepi,rmax,lprwf,wfrmax,turnmax,minnop,rafin,numax,nlam,
     x	 nsturm,buttle,prbut,pralpha,prsturm,prmats,pertcent,prrexp,
     x	 Vsturm,rsturm,asturm,A,kind,   prtran,steps,rmaxsc,fadex,
     x 	 ebeg,estep,emax,prrm,prkm,prtm,e1only,wfs,prns,mlpr,rinte,
     x   nogscat,maxtry,rfact,rafix,gfact,APFLG,MBLOCK,eeigmax,strfun,
     x   rtrans,htrans,maxnop,xlrgs,meigs,pripot,tinside,simeq,
     X   elinear,ltransmax,ktransmax,cutl,cutr,vdiag,rdiag,adiag,
     X   kdiag,nidiag,discrete)
	implicit real*8 (a-h,o-z)
	logical prbut,prns,pralpha,prsturm,prrm,prkm,prtm,prmats,
     x		wfs,e1only,pertcent,prrexp,prtran,strfun,nogscat,
     x		elinear,discrete,pripot,simeq,xlrgs
	real*8 Eo(2),vdiag(2)
	character sturm(2)
	integer buttle,fadex,APFLG(5),nlam(20)
	
	Eo(1) = -0.0
	Eo(2) = -0.0
	sturm(1) = 'f'
	sturm(2) = 'f'
	pertcent = .true.
	pertcent = .false.
	simeq = .false.
	cutl = 1.6
	cutr = 0.0
	vdiag(1) = 0.0
	vdiag(2) = 0.0
	rdiag = 0.0
	adiag = 0.0
	kdiag = 3
	nidiag = 0
	egsmin = -1.0
	egsmax = 0.0
	ngsmax = 0
	maxset = 0
!			The defaults for these are set in readcc:
!	nogscat = .true.
!	eeigmax = 50
	meigs = 0
	ipflg = 0
	numax = 3
	nlam(:) = 2
	stepi = 0.05
	steps = 1.00
	rmax = 20
	rmaxsc = 0.0
	tinside = -1.0
	lprwf = 1
	wfrmax = rmax*2.0
	wfrmax = 0.0
	turnmax = -wfrmax
	minnop = 6
	maxnop = 20
	rafin = 0.
	rafix = 1d5
	rfact = 1.2
	maxtry = 100
	gfact  = 0.3d0
	nsturm = 20
	buttle = 5
	prbut   = .false.
	pripot  = .false.
	pralpha = .false.
	prsturm = .false.
	prmats = .false.
	prrexp = .false.
	prtran = .false.
	kind = 9
	Vsturm = -50.0
	rsturm = 1.2
	asturm = 0.6
	A = 10.0
	ebeg = 0.1
	estep = 0.1
	emax = 0.0
	elinear = .false.
	discrete = .false.
	xlrgs = .true.
	strfun = .false.
	prrm = .false.
	prkm = .false.
	prtm = .false.
	e1only = .false.
	wfs = .false.
	mlpr = 1
	rinte = 10.0
	fadex = 1
	prns = .false.
	do 10 i=1,5
10	APFLG(i) = 0
	MBLOCK = -1
	htrans=0.1
	rtrans=0.0
	ktransmax=6
	ltransmax=2
	return
	end

