      SUBROUTINE KMATM(NC,RA,PPN,IOP,NOP,F,FP,RMAT,BBLOCH,KMAT)
      IMPLICIT INTEGER (A-Z)
      REAL*8 RA,AA,BB,F,FP,RMAT,KMAT,ZERO,DF,BBLOCH,ONE,PPN
      PARAMETER ( ZERO=0.0D0 , ONE=1d0)
      COMMON /DIMRMAT/ MCHAN3
      DIMENSION RMAT(MCHAN3,MCHAN3),KMAT(MCHAN3,MCHAN3),
     X		F(NC,NC,2),FP(NC,NC,2),PPN(MCHAN3,MCHAN3),
     X          AA(NC,NC),BB(NC,NC),IPVT(NC),IOP(NOP)
      COMMON /IO/ IIN,IOUT
*
      DO 80 J = 1, NC
         DO 70 I = 1, NC
            AA(I,J) = - F(I,J,1)
   70    CONTINUE
   80 CONTINUE
      DO 110 J = 1, NC
         DO 100 K = 1, NC
            DF = RA * FP(K,J,1) - BBLOCH * F(K,J,1)
            DO 90 I = 1, NC
               AA(I,J) = AA(I,J) + RMAT(I,K) * DF
   90       CONTINUE
  100    CONTINUE
  110 CONTINUE
*	   	  Calculate BB = P [F-RF']
      call dgemm('n','n',NC,NC,NC,ONE,PPN,MCHAN3,AA,NC,ZERO,BB,NC)
*
      LHS = 1
      DO 20 J = 1, NC
         KJ = 1
	 DO 5 IO=1,NOP
    5	 IF(J.eq.IOP(IO)) KJ = 2
         DO 10 I = 1, NC
            AA(I,J)   = F(I,J,KJ)
   10    CONTINUE
   20 CONTINUE
      DO 50 J = 1, NC
         KJ = 1
	 DO 25 IO=1,NOP
   25	 IF(J.eq.IOP(IO)) KJ = 2
         DO 40 K = 1, NC
            DF = RA * FP(K,J,KJ) - BBLOCH * F(K,J,KJ)
            DO 30 I = 1, NC
               AA(I,J) = AA(I,J) - RMAT(I,K) * DF
   30       CONTINUE
   40    CONTINUE
   50 CONTINUE
      DO 60 I = 1, NC
         IF ( AA(I,I) .EQ. ZERO ) LHS = 0
   60 CONTINUE
	  if(.false.) then
	   write(6,*) 'PPN matrix is'
           call printm ('PPN ',PPN,NC,NC,MCHAN3)
	   write(6,*) 'BB matrix is minus'
           call printm ('F1  ',F(1,1,1),NC,NC,NC)
	   write(6,*) 'plus ',real(RA),' times'
           call printm ('R   ',RMAT,NC,NC,MCHAN3)
	   write(6,*) 'times ',real(RA),' times'
           call printm ('FP1 ',FP(1,1,1),NC,NC,NC)
           call printm ('FP2 ',FP(1,1,2),NC,NC,NC)
	   write(6,*) 'IOP =',(IOP(I),I=1,NOP),real(BBLOCH)

	   write(6,*) 'K matrix is inverse of'
           call printm ('AA  ',AA,NC,NC,NC)
	   write(6,*) 'multiplied by '
           call printm ('BB  ',BB,NC,NC,NC)
	   endif
      IF ( LHS .GT. 0 ) THEN
         IF ( NC .EQ. 1 ) THEN
            BB(1,1) = BB(1,1) / AA(1,1)
         ELSE
            CALL DGETRF (NC,NC,AA,NC,IPVT,IER)
            IF ( IER .NE. 0 ) THEN
               WRITE (IOUT,1000) IER
               STOP
            ENDIF
            CALL DGETRS('N',NC,NC,AA,NC,IPVT,BB,NC,IER)
            IF ( IER .NE. 0 ) THEN
               WRITE (IOUT,1010) IER
               STOP
            ENDIF
         ENDIF
         DO 130 IOJ = 1, NOP
            DO 120 IOI = 1, NOP
               KMAT(IOI,IOJ) = BB(IOP(IOI),IOP(IOJ))
  120       CONTINUE
  130    CONTINUE
      ELSE
	write(6,*) 'NO K-matrix solution possible!'
           call printm ('AA  ',AA,NC,NC,NC)
      ENDIF
      RETURN
 1000 FORMAT (' KMAT : ERROR RETURN FROM DGETRF, IERR = ',I6)
 1010 FORMAT (' KMAT : ERROR RETURN FROM DGETRS, IERR = ',I6)
      END
